;--- include file created by h2incx v0.99.20 (copyright 2005-2009 japheth)
;--- source file: C:\Program Files\Microsoft SDKs\Windows\v7.1\Include\d3d10_1shader.h, last modified: 4/19/2010 21:44
;--- cmdline used for creation:  -v -W3  -c -i -y -d3 -r -I "C:\Program Files (x86)\Microsoft Visual Studio 10.0\VC\include" -o "E:\Eigene Dateien\Dokumente\H2IncX\DX11" "C:\Program Files\Microsoft SDKs\Windows\v7.1\Include\d3d11.h"

;//////////////////////////////////////////////////////////////////////////////
;//
;//  Copyright (c) Microsoft Corporation.  All rights reserved.
;//
;//  File:       D3D10_1Shader.h
;//  Content:    D3D10.1 Shader Types and APIs
;//
;//////////////////////////////////////////////////////////////////////////////
ifndef __D3D10_1SHADER_H__
__D3D10_1SHADER_H__	EQU	<>
	include d3d10shader.inc
;//----------------------------------------------------------------------------
;// Shader debugging structures
;//----------------------------------------------------------------------------
D3D10_SHADER_DEBUG_REGTYPE typedef DWORD
D3D10_SHADER_DEBUG_REG_INPUT = 0
D3D10_SHADER_DEBUG_REG_OUTPUT = 1
D3D10_SHADER_DEBUG_REG_CBUFFER = 2
D3D10_SHADER_DEBUG_REG_TBUFFER = 3
D3D10_SHADER_DEBUG_REG_TEMP = 4
D3D10_SHADER_DEBUG_REG_TEMPARRAY = 5
D3D10_SHADER_DEBUG_REG_TEXTURE = 6
D3D10_SHADER_DEBUG_REG_SAMPLER = 7
D3D10_SHADER_DEBUG_REG_IMMEDIATECBUFFER = 8
D3D10_SHADER_DEBUG_REG_LITERAL = 9
D3D10_SHADER_DEBUG_REG_UNUSED = 10
D3D11_SHADER_DEBUG_REG_INTERFACE_POINTERS = 11
D3D10_SHADER_DEBUG_REG_FORCE_DWORD = 7fffffffh

D3D10_SHADER_DEBUG_SCOPETYPE typedef DWORD
D3D10_SHADER_DEBUG_SCOPE_GLOBAL = 0
D3D10_SHADER_DEBUG_SCOPE_BLOCK = 1
D3D10_SHADER_DEBUG_SCOPE_FORLOOP = 2
D3D10_SHADER_DEBUG_SCOPE_STRUCT = 3
D3D10_SHADER_DEBUG_SCOPE_FUNC_PARAMS = 4
D3D10_SHADER_DEBUG_SCOPE_STATEBLOCK = 5
D3D10_SHADER_DEBUG_SCOPE_NAMESPACE = 6
D3D10_SHADER_DEBUG_SCOPE_ANNOTATION = 7
D3D10_SHADER_DEBUG_SCOPE_FORCE_DWORD = 7fffffffh

D3D10_SHADER_DEBUG_VARTYPE typedef DWORD
D3D10_SHADER_DEBUG_VAR_VARIABLE = 0
D3D10_SHADER_DEBUG_VAR_FUNCTION = 1
D3D10_SHADER_DEBUG_VAR_FORCE_DWORD = 7fffffffh

;/////////////////////////////////////////////////////////////////////
;// These are the serialized structures that get written to the file
;/////////////////////////////////////////////////////////////////////
D3D10_SHADER_DEBUG_TOKEN_INFO	struct
	File			DWORD	?		;// offset into file list
	Line			DWORD	?		;// line #
	Column		DWORD	?		;// column #
	TokenLength	DWORD	?
	TokenId		DWORD	?	;// offset to LPCSTR of length TokenLength in string datastore
D3D10_SHADER_DEBUG_TOKEN_INFO	ends

;// Variable list
D3D10_SHADER_DEBUG_VAR_INFO	struct
	;// Index into token list for declaring identifier
	TokenId		DWORD	?
	Type_		D3D10_SHADER_VARIABLE_TYPE	?
	;// register and component for this variable, only valid/necessary for arrays
	Register		DWORD	?
	Component		DWORD	?
	;// gives the original variable that declared this variable
	ScopeVar		DWORD	?
	;// this variable's offset in its ScopeVar
	ScopeVarOffset	DWORD	?
D3D10_SHADER_DEBUG_VAR_INFO	ends

D3D10_SHADER_DEBUG_INPUT_INFO	struct
	;// index into array of variables of variable to initialize
	Var	DWORD	?
	;// input, cbuffer, tbuffer
	InitialRegisterSet	D3D10_SHADER_DEBUG_REGTYPE	?
	;// set to cbuffer or tbuffer slot, geometry shader input primitive #,
	;// identifying register for indexable temp, or -1
	InitialBank	DWORD	?
	;// -1 if temp, otherwise gives register in register set
	InitialRegister	DWORD	?
	;// -1 if temp, otherwise gives component
	InitialComponent	DWORD	?
	;// initial value if literal
	InitialValue	DWORD	?
D3D10_SHADER_DEBUG_INPUT_INFO	ends

D3D10_SHADER_DEBUG_SCOPEVAR_INFO	struct
	;// Index into variable token
	TokenId			DWORD	?
	VarType			D3D10_SHADER_DEBUG_VARTYPE	?	;// variable or function (different namespaces)
	Class			D3D10_SHADER_VARIABLE_CLASS	?
	Rows				DWORD	?					;// number of rows (matrices)
	Columns			DWORD	?					;// number of columns (vectors and matrices)
	;// In an array of structures, one struct member scope is provided, and
	;// you'll have to add the array stride times the index to the variable
	;// index you find, then find that variable in this structure's list of
	;// variables.
	;// gives a scope to look up struct members. -1 if not a struct
	StructMemberScope	DWORD	?
	;// number of array indices
	uArrayIndices		DWORD	?	;// a[3][2][1] has 3 indices
	;// maximum array index for each index
	;// offset to UINT[uArrayIndices] in UINT datastore
	ArrayElements		DWORD	?	;// a[3][2][1] has {3, 2, 1}
	;// how many variables each array index moves
	;// offset to UINT[uArrayIndices] in UINT datastore
	ArrayStrides		DWORD	?	;// a[3][2][1] has {2, 1, 1}
	uVariables		DWORD	?
	;// index of the first variable, later variables are offsets from this one
	uFirstVariable		DWORD	?
D3D10_SHADER_DEBUG_SCOPEVAR_INFO	ends

;// scope data, this maps variable names to debug variables (useful for the watch window)
D3D10_SHADER_DEBUG_SCOPE_INFO	struct
	ScopeType	D3D10_SHADER_DEBUG_SCOPETYPE	?
	Name_		DWORD	?	;// offset to name of scope in strings list
	uNameLen		DWORD	?	;// length of name string
	uVariables	DWORD	?
	VariableData	DWORD	?	;// Offset to UINT[uVariables] indexing the Scope Variable list
D3D10_SHADER_DEBUG_SCOPE_INFO	ends

;// instruction outputs
D3D10_SHADER_DEBUG_OUTPUTVAR	struct
	;// index variable being written to, if -1 it's not going to a variable
	Var			DWORD	?
	;// range data that the compiler expects to be true
	uValueMin		DWORD	?
	uValueMax		DWORD	?
	iValueMin		DWORD	?
	iValueMax		DWORD	?
	fValueMin		REAL4	?
	fValueMax		REAL4	?
	bNaNPossible	BOOL	?
	bInfPossible	BOOL	?
D3D10_SHADER_DEBUG_OUTPUTVAR	ends

D3D10_SHADER_DEBUG_OUTPUTREG_INFO	struct
	;// Only temp, indexable temp, and output are valid here
	OutputRegisterSet	D3D10_SHADER_DEBUG_REGTYPE	?
	;// -1 means no output
	OutputReg			DWORD	?
	;// if a temp array, identifier for which one
	TempArrayReg		DWORD	?
	;// -1 means masked out
	OutputComponents	DWORD 4 dup (?)
	OutputVars		D3D10_SHADER_DEBUG_OUTPUTVAR 4 dup (<>)
	;// when indexing the output, get the value of this register, then add
	;// that to uOutputReg. If uIndexReg is -1, then there is no index.
	;// find the variable whose register is the sum (by looking in the ScopeVar)
	;// and component matches, then set it. This should only happen for indexable
	;// temps and outputs.
	IndexReg			DWORD	?
	IndexComp			DWORD	?
D3D10_SHADER_DEBUG_OUTPUTREG_INFO	ends

;// per instruction data
D3D10_SHADER_DEBUG_INST_INFO	struct
	Id				DWORD	?	;// Which instruction this is in the bytecode
	Opcode			DWORD	?	;// instruction type
	;// 0, 1, or 2
	uOutputs			DWORD	?
	;// up to two outputs per instruction
	pOutputs			D3D10_SHADER_DEBUG_OUTPUTREG_INFO 2 dup (<>)
	;// index into the list of tokens for this instruction's token
	TokenId			DWORD	?
	;// how many function calls deep this instruction is
	NestingLevel		DWORD	?
	;// list of scopes from outer-most to inner-most
	;// Number of scopes
	Scopes			DWORD	?
	ScopeInfo			DWORD	?	;// Offset to UINT[uScopes] specifying indices of the ScopeInfo Array
	;// list of variables accessed by this instruction
	;// Number of variables
	AccessedVars		DWORD	?
	AccessedVarsInfo	DWORD	?	;// Offset to UINT[AccessedVars] specifying indices of the ScopeVariableInfo Array
D3D10_SHADER_DEBUG_INST_INFO	ends

D3D10_SHADER_DEBUG_FILE_INFO	struct
	FileName		DWORD	?		;// Offset to LPCSTR for file name
	FileNameLen	DWORD	?		;// Length of file name
	FileData		DWORD	?		;// Offset to LPCSTR of length FileLen
	FileLen		DWORD	?		;// Length of file
D3D10_SHADER_DEBUG_FILE_INFO	ends

D3D10_SHADER_DEBUG_INFO	struct
Size_			DWORD	?	;// sizeof(D3D10_SHADER_DEBUG_INFO)
Creator			DWORD	?	;// Offset to LPCSTR for compiler version
EntrypointName		DWORD	?	;// Offset to LPCSTR for Entry point name
ShaderTarget		DWORD	?	;// Offset to LPCSTR for shader target
CompileFlags		DWORD	?	;// flags used to compile
Files			DWORD	?	;// number of included files
FileInfo			DWORD	?	;// Offset to D3D10_SHADER_DEBUG_FILE_INFO[Files]
Instructions		DWORD	?	;// number of instructions
InstructionInfo	DWORD	?	;// Offset to D3D10_SHADER_DEBUG_INST_INFO[Instructions]
Variables			DWORD	?	;// number of variables
VariableInfo		DWORD	?	;// Offset to D3D10_SHADER_DEBUG_VAR_INFO[Variables]
InputVariables		DWORD	?	;// number of variables to initialize before running
InputVariableInfo	DWORD	?	;// Offset to D3D10_SHADER_DEBUG_INPUT_INFO[InputVariables]
Tokens			DWORD	?	;// number of tokens to initialize
TokenInfo			DWORD	?	;// Offset to D3D10_SHADER_DEBUG_TOKEN_INFO[Tokens]
Scopes			DWORD	?	;// number of scopes
ScopeInfo			DWORD	?	;// Offset to D3D10_SHADER_DEBUG_SCOPE_INFO[Scopes]
ScopeVariables		DWORD	?	;// number of variables declared
ScopeVariableInfo	DWORD	?	;// Offset to D3D10_SHADER_DEBUG_SCOPEVAR_INFO[Scopes]
UintOffset		DWORD	?	;// Offset to the UINT datastore, all UINT offsets are from this offset
StringOffset		DWORD	?	;// Offset to the string datastore, all string offsets are from this offset
D3D10_SHADER_DEBUG_INFO	ends

;//----------------------------------------------------------------------------
;// ID3D10ShaderReflection1:
;//----------------------------------------------------------------------------
;//
;// Interface definitions
;//
;ID3D10ShaderReflection1 typedef ID3D10ShaderReflection1

LPD3D10SHADERREFLECTION1 typedef ptr ID3D10ShaderReflection1

;// {C3457783-A846-47CE-9520-CEA6F66E7447}
DEFINE_GUID( IID_ID3D10ShaderReflection1 , 0c3457783h , 0a846h , 47ceh , 95h , 20h , 0ceh , 0a6h , 0f6h , 6eh , 74h , 47h)
;#undef INTERFACE
INTERFACE	EQU	<ID3D10ShaderReflection1>
DECLARE_INTERFACE_( ID3D10ShaderReflection1 , IUnknown)
;{
STDMETHOD  QueryInterface , :REFIID, :ptr LPVOID
STDMETHOD_  ULONG , AddRef
STDMETHOD_  ULONG , Release
STDMETHOD  GetDesc , :ptr D3D10_SHADER_DESC
STDMETHOD_  ID3D10ShaderReflectionConstantBuffer * , GetConstantBufferByIndex , :DWORD
STDMETHOD_  ID3D10ShaderReflectionConstantBuffer * , GetConstantBufferByName , :LPSTR
STDMETHOD  GetResourceBindingDesc , :DWORD, :ptr D3D10_SHADER_INPUT_BIND_DESC
STDMETHOD  GetInputParameterDesc , :DWORD, :ptr D3D10_SIGNATURE_PARAMETER_DESC
STDMETHOD  GetOutputParameterDesc , :DWORD, :ptr D3D10_SIGNATURE_PARAMETER_DESC
STDMETHOD_  ID3D10ShaderReflectionVariable * , GetVariableByName , :LPSTR
STDMETHOD  GetResourceBindingDescByName , :LPSTR, :ptr D3D10_SHADER_INPUT_BIND_DESC
STDMETHOD  GetMovInstructionCount , :ptr DWORD
STDMETHOD  GetMovcInstructionCount , :ptr DWORD
STDMETHOD  GetConversionInstructionCount , :ptr DWORD
STDMETHOD  GetBitwiseInstructionCount , :ptr DWORD
STDMETHOD  GetGSInputPrimitive , :ptr D3D10_PRIMITIVE
STDMETHOD  IsLevel9Shader , :ptr BOOL
STDMETHOD  IsSampleFrequencyShader , :ptr BOOL
;}
DECLARE_INTERFACE__END

;//////////////////////////////////////////////////////////////////////////////
;// APIs //////////////////////////////////////////////////////////////////////
;//////////////////////////////////////////////////////////////////////////////
ifdef __cplusplus
;extern "C"
;{
endif ;//__cplusplus
ifdef __cplusplus
;}
endif ;//__cplusplus
endif ;//__D3D10_1SHADER_H__

;--- warnings: 3
;--- errors: 0
;--- end of file ---
