;--- include file created by h2incx v0.99.20 (copyright 2005-2009 japheth)
;--- source file: C:\Program Files\Microsoft SDKs\Windows\v7.1\Include\d3d10effect.h, last modified: 4/19/2010 21:44
;--- cmdline used for creation:  -v -W3  -c -i -y -d3 -r -I "C:\Program Files (x86)\Microsoft Visual Studio 10.0\VC\include" -o "E:\Eigene Dateien\Dokumente\H2IncX\DX11" "C:\Program Files\Microsoft SDKs\Windows\v7.1\Include\d3d11.h"

;//////////////////////////////////////////////////////////////////////////////
;//
;//  Copyright (c) Microsoft Corporation.  All rights reserved.
;//
;//  File:       D3D10Effect.h
;//  Content:    D3D10 Stateblock/Effect Types & APIs
;//
;//////////////////////////////////////////////////////////////////////////////
ifndef __D3D10EFFECT_H__
__D3D10EFFECT_H__	EQU	<>
	include d3d10.inc
;//////////////////////////////////////////////////////////////////////////////
;// File contents:
;//
;// 1) Stateblock enums, structs, interfaces, flat APIs
;// 2) Effect enums, structs, interfaces, flat APIs
;//////////////////////////////////////////////////////////////////////////////
;//----------------------------------------------------------------------------
;// D3D10_DEVICE_STATE_TYPES:
;//
;// Used in ID3D10StateBlockMask function calls
;//
;//----------------------------------------------------------------------------
D3D10_DEVICE_STATE_TYPES typedef DWORD
D3D10_DST_SO_BUFFERS = 1				;// Single-value state (atomical gets/sets)
D3D10_DST_OM_RENDER_TARGETS = 2		;// Single-value state (atomical gets/sets)
D3D10_DST_OM_DEPTH_STENCIL_STATE = 3	;// Single-value state
D3D10_DST_OM_BLEND_STATE = 4			;// Single-value state
D3D10_DST_VS = 5					;// Single-value state
D3D10_DST_VS_SAMPLERS = 6			;// Count: D3D10_COMMONSHADER_SAMPLER_SLOT_COUNT
D3D10_DST_VS_SHADER_RESOURCES = 7		;// Count: D3D10_COMMONSHADER_INPUT_RESOURCE_SLOT_COUNT
D3D10_DST_VS_CONSTANT_BUFFERS = 8		;// Count:
D3D10_DST_GS = 9					;// Single-value state
D3D10_DST_GS_SAMPLERS = 10			;// Count: D3D10_COMMONSHADER_SAMPLER_SLOT_COUNT
D3D10_DST_GS_SHADER_RESOURCES = 11		;// Count: D3D10_COMMONSHADER_INPUT_RESOURCE_SLOT_COUNT
D3D10_DST_GS_CONSTANT_BUFFERS = 12		;// Count: D3D10_COMMONSHADER_CONSTANT_BUFFER_API_SLOT_COUNT
D3D10_DST_PS = 13					;// Single-value state
D3D10_DST_PS_SAMPLERS = 14			;// Count: D3D10_COMMONSHADER_SAMPLER_SLOT_COUNT
D3D10_DST_PS_SHADER_RESOURCES = 15		;// Count: D3D10_COMMONSHADER_INPUT_RESOURCE_SLOT_COUNT
D3D10_DST_PS_CONSTANT_BUFFERS = 16		;// Count: D3D10_COMMONSHADER_CONSTANT_BUFFER_API_SLOT_COUNT
D3D10_DST_IA_VERTEX_BUFFERS = 17		;// Count: D3D10_IA_VERTEX_INPUT_RESOURCE_SLOT_COUNT
D3D10_DST_IA_INDEX_BUFFER = 18		;// Single-value state
D3D10_DST_IA_INPUT_LAYOUT = 19		;// Single-value state
D3D10_DST_IA_PRIMITIVE_TOPOLOGY = 20	;// Single-value state
D3D10_DST_RS_VIEWPORTS = 21			;// Single-value state (atomical gets/sets)
D3D10_DST_RS_SCISSOR_RECTS = 22		;// Single-value state (atomical gets/sets)
D3D10_DST_RS_RASTERIZER_STATE = 23		;// Single-value state
D3D10_DST_PREDICATION = 24			;// Single-value state

;//----------------------------------------------------------------------------
;// D3D10_DEVICE_STATE_TYPES:
;//
;// Used in ID3D10StateBlockMask function calls
;//
;//----------------------------------------------------------------------------
ifndef D3D10_BYTES_FROM_BITS
D3D10_BYTES_FROM_BITS macro x
	exitm <( ( ( x ) + 7 ) / 8 ) >
	endm
endif ;// D3D10_BYTES_FROM_BITS
D3D10_STATE_BLOCK_MASK	struct
	VS				BYTE	?
	VSSamplers		BYTE D3D10_BYTES_FROM_BITS(D3D10_COMMONSHADER_SAMPLER_SLOT_COUNT) dup (?)
	VSShaderResources	BYTE D3D10_BYTES_FROM_BITS(D3D10_COMMONSHADER_INPUT_RESOURCE_SLOT_COUNT) dup (?)
	VSConstantBuffers	BYTE D3D10_BYTES_FROM_BITS(D3D10_COMMONSHADER_CONSTANT_BUFFER_API_SLOT_COUNT) dup (?)
	GS_				BYTE	?
	GSSamplers		BYTE D3D10_BYTES_FROM_BITS(D3D10_COMMONSHADER_SAMPLER_SLOT_COUNT) dup (?)
	GSShaderResources	BYTE D3D10_BYTES_FROM_BITS(D3D10_COMMONSHADER_INPUT_RESOURCE_SLOT_COUNT) dup (?)
	GSConstantBuffers	BYTE D3D10_BYTES_FROM_BITS(D3D10_COMMONSHADER_CONSTANT_BUFFER_API_SLOT_COUNT) dup (?)
	PS				BYTE	?
	PSSamplers		BYTE D3D10_BYTES_FROM_BITS(D3D10_COMMONSHADER_SAMPLER_SLOT_COUNT) dup (?)
	PSShaderResources	BYTE D3D10_BYTES_FROM_BITS(D3D10_COMMONSHADER_INPUT_RESOURCE_SLOT_COUNT) dup (?)
	PSConstantBuffers	BYTE D3D10_BYTES_FROM_BITS(D3D10_COMMONSHADER_CONSTANT_BUFFER_API_SLOT_COUNT) dup (?)
	IAVertexBuffers	BYTE D3D10_BYTES_FROM_BITS(D3D10_IA_VERTEX_INPUT_RESOURCE_SLOT_COUNT) dup (?)
	IAIndexBuffer		BYTE	?
	IAInputLayout		BYTE	?
	IAPrimitiveTopology	BYTE	?
	OMRenderTargets	BYTE	?
	OMDepthStencilState	BYTE	?
	OMBlendState		BYTE	?
	RSViewports		BYTE	?
	RSScissorRects		BYTE	?
	RSRasterizerState	BYTE	?
	SOBuffers			BYTE	?
	Predication		BYTE	?
D3D10_STATE_BLOCK_MASK	ends

;//////////////////////////////////////////////////////////////////////////////
;// ID3D10StateBlock //////////////////////////////////////////////////////////
;//////////////////////////////////////////////////////////////////////////////
;ID3D10StateBlock typedef ID3D10StateBlock

LPD3D10STATEBLOCK typedef ptr ID3D10StateBlock

;// {0803425A-57F5-4dd6-9465-A87570834A08}
DEFINE_GUID( IID_ID3D10StateBlock , 803425ah , 57f5h , 4dd6h , 94h , 65h , 0a8h , 75h , 70h , 83h , 4ah , 8h)
;#undef INTERFACE
INTERFACE	EQU	<ID3D10StateBlock>
DECLARE_INTERFACE_( ID3D10StateBlock , IUnknown)
;{
STDMETHOD  QueryInterface , :REFIID, :ptr LPVOID
STDMETHOD_  ULONG , AddRef
STDMETHOD_  ULONG , Release
STDMETHOD  Capture
STDMETHOD  Apply
STDMETHOD  ReleaseAllDeviceObjects
STDMETHOD  GetDevice , :ptr ptr ID3D10Device
;}
DECLARE_INTERFACE__END

ifdef __cplusplus
;extern "C"
;{
endif ;//__cplusplus
;//----------------------------------------------------------------------------
;// D3D10_STATE_BLOCK_MASK and manipulation functions
;// -------------------------------------------------
;//
;// These functions exist to facilitate working with the D3D10_STATE_BLOCK_MASK
;// structure.
;//
;// D3D10_STATE_BLOCK_MASK *pResult or *pMask
;//   The state block mask to operate on
;//
;// D3D10_STATE_BLOCK_MASK *pA, *pB
;//   The source state block masks for the binary union/intersect/difference
;//   operations.
;//
;// D3D10_DEVICE_STATE_TYPES StateType
;//   The specific state type to enable/disable/query
;//
;// UINT RangeStart, RangeLength, Entry
;//   The specific bit or range of bits for a given state type to operate on.
;//   Consult the comments for D3D10_DEVICE_STATE_TYPES and
;//   D3D10_STATE_BLOCK_MASK for information on the valid bit ranges for
;//   each state.
;//
;//----------------------------------------------------------------------------
D3D10StateBlockMaskUnion proto WINSTDCALLCONV :ptr D3D10_STATE_BLOCK_MASK, :ptr D3D10_STATE_BLOCK_MASK, :ptr D3D10_STATE_BLOCK_MASK
D3D10StateBlockMaskIntersect proto WINSTDCALLCONV :ptr D3D10_STATE_BLOCK_MASK, :ptr D3D10_STATE_BLOCK_MASK, :ptr D3D10_STATE_BLOCK_MASK
D3D10StateBlockMaskDifference proto WINSTDCALLCONV :ptr D3D10_STATE_BLOCK_MASK, :ptr D3D10_STATE_BLOCK_MASK, :ptr D3D10_STATE_BLOCK_MASK
D3D10StateBlockMaskEnableCapture proto WINSTDCALLCONV :ptr D3D10_STATE_BLOCK_MASK, :D3D10_DEVICE_STATE_TYPES, :DWORD, :DWORD
D3D10StateBlockMaskDisableCapture proto WINSTDCALLCONV :ptr D3D10_STATE_BLOCK_MASK, :D3D10_DEVICE_STATE_TYPES, :DWORD, :DWORD
D3D10StateBlockMaskEnableAll proto WINSTDCALLCONV :ptr D3D10_STATE_BLOCK_MASK
D3D10StateBlockMaskDisableAll proto WINSTDCALLCONV :ptr D3D10_STATE_BLOCK_MASK
D3D10StateBlockMaskGetSetting proto WINSTDCALLCONV :ptr D3D10_STATE_BLOCK_MASK, :D3D10_DEVICE_STATE_TYPES, :DWORD
;//----------------------------------------------------------------------------
;// D3D10CreateStateBlock
;// ---------------------
;//
;// Creates a state block object based on the mask settings specified
;//   in a D3D10_STATE_BLOCK_MASK structure.
;//
;// ID3D10Device *pDevice
;//      The device interface to associate with this state block
;//
;// D3D10_STATE_BLOCK_MASK *pStateBlockMask
;//      A bit mask whose settings are used to generate a state block
;//      object.
;//
;// ID3D10StateBlock **ppStateBlock
;//      The resulting state block object.  This object will save/restore
;//      only those pieces of state that were set in the state block
;//      bit mask
;//----------------------------------------------------------------------------
D3D10CreateStateBlock proto WINSTDCALLCONV :ptr ID3D10Device, :ptr D3D10_STATE_BLOCK_MASK, :ptr ptr ID3D10StateBlock
ifdef __cplusplus
;}
endif ;//__cplusplus
;//----------------------------------------------------------------------------
;// D3D10_COMPILE & D3D10_EFFECT flags:
;// -------------------------------------
;//
;// These flags are passed in when creating an effect, and affect
;// either compilation behavior or runtime effect behavior
;//
;// D3D10_EFFECT_COMPILE_CHILD_EFFECT
;//   Compile this .fx file to a child effect. Child effects have no initializers
;//   for any shared values as these are initialied in the master effect (pool).
;//
;// D3D10_EFFECT_COMPILE_ALLOW_SLOW_OPS
;//   By default, performance mode is enabled.  Performance mode disallows
;//   mutable state objects by preventing non-literal expressions from appearing in
;//   state object definitions.  Specifying this flag will disable the mode and allow
;//   for mutable state objects.
;//
;// D3D10_EFFECT_SINGLE_THREADED
;//   Do not attempt to synchronize with other threads loading effects into the
;//   same pool.
;//
;//----------------------------------------------------------------------------
D3D10_EFFECT_COMPILE_CHILD_EFFECT	EQU	( 1  shl  0 )
D3D10_EFFECT_COMPILE_ALLOW_SLOW_OPS	EQU	( 1  shl  1 )
D3D10_EFFECT_SINGLE_THREADED	EQU	( 1  shl  3 )
;//----------------------------------------------------------------------------
;// D3D10_EFFECT_VARIABLE flags:
;// ----------------------------
;//
;// These flags describe an effect variable (global or annotation),
;// and are returned in D3D10_EFFECT_VARIABLE_DESC::Flags.
;//
;// D3D10_EFFECT_VARIABLE_POOLED
;//   Indicates that the this variable or constant buffer resides
;//   in an effect pool. If this flag is not set, then the variable resides
;//   in a standalone effect (if ID3D10Effect::GetPool returns NULL)
;//   or a child effect (if ID3D10Effect::GetPool returns non-NULL)
;//
;// D3D10_EFFECT_VARIABLE_ANNOTATION
;//   Indicates that this is an annotation on a technique, pass, or global
;//   variable. Otherwise, this is a global variable. Annotations cannot
;//   be shared.
;//
;// D3D10_EFFECT_VARIABLE_EXPLICIT_BIND_POINT
;//   Indicates that the variable has been explicitly bound using the
;//   register keyword.
;//----------------------------------------------------------------------------
D3D10_EFFECT_VARIABLE_POOLED	EQU	( 1  shl  0 )
D3D10_EFFECT_VARIABLE_ANNOTATION	EQU	( 1  shl  1 )
D3D10_EFFECT_VARIABLE_EXPLICIT_BIND_POINT	EQU	( 1  shl  2 )
;//////////////////////////////////////////////////////////////////////////////
;// ID3D10EffectType //////////////////////////////////////////////////////////
;//////////////////////////////////////////////////////////////////////////////
;//----------------------------------------------------------------------------
;// D3D10_EFFECT_TYPE_DESC:
;//
;// Retrieved by ID3D10EffectType::GetDesc()
;//----------------------------------------------------------------------------
D3D10_EFFECT_TYPE_DESC	struct
	TypeName		LPSTR	?					;// Name of the type
											;// (e.g. "float4" or "MyStruct")
	Class		D3D10_SHADER_VARIABLE_CLASS	?	;// (e.g. scalar, vector, object, etc.)
	Type_		D3D10_SHADER_VARIABLE_TYPE	?	;// (e.g. float, texture, vertexshader, etc.)
	Elements		DWORD	?					;// Number of elements in this type
											;// (0 if not an array)
	Members		DWORD	?					;// Number of members
											;// (0 if not a structure)
	Rows			DWORD	?					;// Number of rows in this type
											;// (0 if not a numeric primitive)
	Columns		DWORD	?					;// Number of columns in this type
											;// (0 if not a numeric primitive)
	PackedSize	DWORD	?					;// Number of bytes required to represent
											;// this data type, when tightly packed
	UnpackedSize	DWORD	?					;// Number of bytes occupied by this data
											;// type, when laid out in a constant buffer
	Stride		DWORD	?					;// Number of bytes to seek between elements,
											;// when laid out in a constant buffer
D3D10_EFFECT_TYPE_DESC	ends

;ID3D10EffectType typedef ID3D10EffectType

LPD3D10EFFECTTYPE typedef ptr ID3D10EffectType

;// {4E9E1DDC-CD9D-4772-A837-00180B9B88FD}
DEFINE_GUID( IID_ID3D10EffectType , 4e9e1ddch , 0cd9dh , 4772h , 0a8h , 37h , 0h , 18h , 0bh , 9bh , 88h , 0fdh)
;#undef INTERFACE
INTERFACE	EQU	<ID3D10EffectType>
DECLARE_INTERFACE( ID3D10EffectType)
;{
STDMETHOD_  BOOL , IsValid
STDMETHOD  GetDesc , :ptr D3D10_EFFECT_TYPE_DESC
STDMETHOD_  ID3D10EffectType * , GetMemberTypeByIndex , :DWORD
STDMETHOD_  ID3D10EffectType * , GetMemberTypeByName , :LPSTR
STDMETHOD_  ID3D10EffectType * , GetMemberTypeBySemantic , :LPSTR
STDMETHOD_  LPCSTR , GetMemberName , :DWORD
STDMETHOD_  LPCSTR , GetMemberSemantic , :DWORD
;}
DECLARE_INTERFACE_END

;//////////////////////////////////////////////////////////////////////////////
;// ID3D10EffectVariable //////////////////////////////////////////////////////
;//////////////////////////////////////////////////////////////////////////////
;//----------------------------------------------------------------------------
;// D3D10_EFFECT_VARIABLE_DESC:
;//
;// Retrieved by ID3D10EffectVariable::GetDesc()
;//----------------------------------------------------------------------------
D3D10_EFFECT_VARIABLE_DESC	struct
	Name_			LPSTR	?	;// Name of this variable, annotation,
								;// or structure member
	Semantic			LPSTR	?	;// Semantic string of this variable
								;// or structure member (NULL for
								;// annotations or if not present)
	Flags			DWORD	?	;// D3D10_EFFECT_VARIABLE_* flags
	Annotations		DWORD	?	;// Number of annotations on this variable
								;// (always 0 for annotations)
	BufferOffset		DWORD	?	;// Offset into containing cbuffer or tbuffer
								;// (always 0 for annotations or variables
								;// not in constant buffers)
	ExplicitBindPoint	DWORD	?	;// Used if the variable has been explicitly bound
								;// using the register keyword. Check Flags for
								;// D3D10_EFFECT_VARIABLE_EXPLICIT_BIND_POINT;
D3D10_EFFECT_VARIABLE_DESC	ends

;ID3D10EffectVariable typedef ID3D10EffectVariable

LPD3D10EFFECTVARIABLE typedef ptr ID3D10EffectVariable

;// {AE897105-00E6-45bf-BB8E-281DD6DB8E1B}
DEFINE_GUID( IID_ID3D10EffectVariable , 0ae897105h , 0e6h , 45bfh , 0bbh , 8eh , 28h , 1dh , 0d6h , 0dbh , 8eh , 1bh)
;#undef INTERFACE
INTERFACE	EQU	<ID3D10EffectVariable>
;// Forward defines
;ID3D10EffectScalarVariable typedef ID3D10EffectScalarVariable

;ID3D10EffectVectorVariable typedef ID3D10EffectVectorVariable

;ID3D10EffectMatrixVariable typedef ID3D10EffectMatrixVariable

;ID3D10EffectStringVariable typedef ID3D10EffectStringVariable

;ID3D10EffectShaderResourceVariable typedef ID3D10EffectShaderResourceVariable

;ID3D10EffectRenderTargetViewVariable typedef ID3D10EffectRenderTargetViewVariable

;ID3D10EffectDepthStencilViewVariable typedef ID3D10EffectDepthStencilViewVariable

;ID3D10EffectConstantBuffer typedef ID3D10EffectConstantBuffer

;ID3D10EffectShaderVariable typedef ID3D10EffectShaderVariable

;ID3D10EffectBlendVariable typedef ID3D10EffectBlendVariable

;ID3D10EffectDepthStencilVariable typedef ID3D10EffectDepthStencilVariable

;ID3D10EffectRasterizerVariable typedef ID3D10EffectRasterizerVariable

;ID3D10EffectSamplerVariable typedef ID3D10EffectSamplerVariable

DECLARE_INTERFACE( ID3D10EffectVariable)
;{
STDMETHOD_  BOOL , IsValid
STDMETHOD_  ID3D10EffectType * , GetType
STDMETHOD  GetDesc , :ptr D3D10_EFFECT_VARIABLE_DESC
STDMETHOD_  ID3D10EffectVariable * , GetAnnotationByIndex , :DWORD
STDMETHOD_  ID3D10EffectVariable * , GetAnnotationByName , :LPSTR
STDMETHOD_  ID3D10EffectVariable * , GetMemberByIndex , :DWORD
STDMETHOD_  ID3D10EffectVariable * , GetMemberByName , :LPSTR
STDMETHOD_  ID3D10EffectVariable * , GetMemberBySemantic , :LPSTR
STDMETHOD_  ID3D10EffectVariable * , GetElement , :DWORD
STDMETHOD_  ID3D10EffectConstantBuffer * , GetParentConstantBuffer
STDMETHOD_  ID3D10EffectScalarVariable * , AsScalar
STDMETHOD_  ID3D10EffectVectorVariable * , AsVector
STDMETHOD_  ID3D10EffectMatrixVariable * , AsMatrix
STDMETHOD_  ID3D10EffectStringVariable * , AsString
STDMETHOD_  ID3D10EffectShaderResourceVariable * , AsShaderResource
STDMETHOD_  ID3D10EffectRenderTargetViewVariable * , AsRenderTargetView
STDMETHOD_  ID3D10EffectDepthStencilViewVariable * , AsDepthStencilView
STDMETHOD_  ID3D10EffectConstantBuffer * , AsConstantBuffer
STDMETHOD_  ID3D10EffectShaderVariable * , AsShader
STDMETHOD_  ID3D10EffectBlendVariable * , AsBlend
STDMETHOD_  ID3D10EffectDepthStencilVariable * , AsDepthStencil
STDMETHOD_  ID3D10EffectRasterizerVariable * , AsRasterizer
STDMETHOD_  ID3D10EffectSamplerVariable * , AsSampler
STDMETHOD  SetRawValue , :ptr , :DWORD, :DWORD
STDMETHOD  GetRawValue , :ptr , :DWORD, :DWORD
;}
DECLARE_INTERFACE_END

;//////////////////////////////////////////////////////////////////////////////
;// ID3D10EffectScalarVariable ////////////////////////////////////////////////
;//////////////////////////////////////////////////////////////////////////////
;ID3D10EffectScalarVariable typedef ID3D10EffectScalarVariable

LPD3D10EFFECTSCALARVARIABLE typedef ptr ID3D10EffectScalarVariable

;// {00E48F7B-D2C8-49e8-A86C-022DEE53431F}
DEFINE_GUID( IID_ID3D10EffectScalarVariable , 0e48f7bh , 0d2c8h , 49e8h , 0a8h , 6ch , 2h , 2dh , 0eeh , 53h , 43h , 1fh)
;#undef INTERFACE
INTERFACE	EQU	<ID3D10EffectScalarVariable>
DECLARE_INTERFACE_( ID3D10EffectScalarVariable , ID3D10EffectVariable)
;{
STDMETHOD_  BOOL , IsValid
STDMETHOD_  ID3D10EffectType * , GetType
STDMETHOD  GetDesc , :ptr D3D10_EFFECT_VARIABLE_DESC
STDMETHOD_  ID3D10EffectVariable * , GetAnnotationByIndex , :DWORD
STDMETHOD_  ID3D10EffectVariable * , GetAnnotationByName , :LPSTR
STDMETHOD_  ID3D10EffectVariable * , GetMemberByIndex , :DWORD
STDMETHOD_  ID3D10EffectVariable * , GetMemberByName , :LPSTR
STDMETHOD_  ID3D10EffectVariable * , GetMemberBySemantic , :LPSTR
STDMETHOD_  ID3D10EffectVariable * , GetElement , :DWORD
STDMETHOD_  ID3D10EffectConstantBuffer * , GetParentConstantBuffer
STDMETHOD_  ID3D10EffectScalarVariable * , AsScalar
STDMETHOD_  ID3D10EffectVectorVariable * , AsVector
STDMETHOD_  ID3D10EffectMatrixVariable * , AsMatrix
STDMETHOD_  ID3D10EffectStringVariable * , AsString
STDMETHOD_  ID3D10EffectShaderResourceVariable * , AsShaderResource
STDMETHOD_  ID3D10EffectRenderTargetViewVariable * , AsRenderTargetView
STDMETHOD_  ID3D10EffectDepthStencilViewVariable * , AsDepthStencilView
STDMETHOD_  ID3D10EffectConstantBuffer * , AsConstantBuffer
STDMETHOD_  ID3D10EffectShaderVariable * , AsShader
STDMETHOD_  ID3D10EffectBlendVariable * , AsBlend
STDMETHOD_  ID3D10EffectDepthStencilVariable * , AsDepthStencil
STDMETHOD_  ID3D10EffectRasterizerVariable * , AsRasterizer
STDMETHOD_  ID3D10EffectSamplerVariable * , AsSampler
STDMETHOD  SetRawValue , :ptr , :DWORD, :DWORD
STDMETHOD  GetRawValue , :ptr , :DWORD, :DWORD
STDMETHOD  SetFloat , :REAL4
STDMETHOD  GetFloat , :ptr REAL4
STDMETHOD  SetFloatArray , :ptr REAL4, :DWORD, :DWORD
STDMETHOD  GetFloatArray , :ptr REAL4, :DWORD, :DWORD
STDMETHOD  SetInt , :DWORD
STDMETHOD  GetInt , :ptr DWORD
STDMETHOD  SetIntArray , :ptr DWORD, :DWORD, :DWORD
STDMETHOD  GetIntArray , :ptr DWORD, :DWORD, :DWORD
STDMETHOD  SetBool , :BOOL
STDMETHOD  GetBool , :ptr BOOL
STDMETHOD  SetBoolArray , :ptr BOOL, :DWORD, :DWORD
STDMETHOD  GetBoolArray , :ptr BOOL, :DWORD, :DWORD
;}
DECLARE_INTERFACE__END

;//////////////////////////////////////////////////////////////////////////////
;// ID3D10EffectVectorVariable ////////////////////////////////////////////////
;//////////////////////////////////////////////////////////////////////////////
;ID3D10EffectVectorVariable typedef ID3D10EffectVectorVariable

LPD3D10EFFECTVECTORVARIABLE typedef ptr ID3D10EffectVectorVariable

;// {62B98C44-1F82-4c67-BCD0-72CF8F217E81}
DEFINE_GUID( IID_ID3D10EffectVectorVariable , 62b98c44h , 1f82h , 4c67h , 0bch , 0d0h , 72h , 0cfh , 8fh , 21h , 7eh , 81h)
;#undef INTERFACE
INTERFACE	EQU	<ID3D10EffectVectorVariable>
DECLARE_INTERFACE_( ID3D10EffectVectorVariable , ID3D10EffectVariable)
;{
STDMETHOD_  BOOL , IsValid
STDMETHOD_  ID3D10EffectType * , GetType
STDMETHOD  GetDesc , :ptr D3D10_EFFECT_VARIABLE_DESC
STDMETHOD_  ID3D10EffectVariable * , GetAnnotationByIndex , :DWORD
STDMETHOD_  ID3D10EffectVariable * , GetAnnotationByName , :LPSTR
STDMETHOD_  ID3D10EffectVariable * , GetMemberByIndex , :DWORD
STDMETHOD_  ID3D10EffectVariable * , GetMemberByName , :LPSTR
STDMETHOD_  ID3D10EffectVariable * , GetMemberBySemantic , :LPSTR
STDMETHOD_  ID3D10EffectVariable * , GetElement , :DWORD
STDMETHOD_  ID3D10EffectConstantBuffer * , GetParentConstantBuffer
STDMETHOD_  ID3D10EffectScalarVariable * , AsScalar
STDMETHOD_  ID3D10EffectVectorVariable * , AsVector
STDMETHOD_  ID3D10EffectMatrixVariable * , AsMatrix
STDMETHOD_  ID3D10EffectStringVariable * , AsString
STDMETHOD_  ID3D10EffectShaderResourceVariable * , AsShaderResource
STDMETHOD_  ID3D10EffectRenderTargetViewVariable * , AsRenderTargetView
STDMETHOD_  ID3D10EffectDepthStencilViewVariable * , AsDepthStencilView
STDMETHOD_  ID3D10EffectConstantBuffer * , AsConstantBuffer
STDMETHOD_  ID3D10EffectShaderVariable * , AsShader
STDMETHOD_  ID3D10EffectBlendVariable * , AsBlend
STDMETHOD_  ID3D10EffectDepthStencilVariable * , AsDepthStencil
STDMETHOD_  ID3D10EffectRasterizerVariable * , AsRasterizer
STDMETHOD_  ID3D10EffectSamplerVariable * , AsSampler
STDMETHOD  SetRawValue , :ptr , :DWORD, :DWORD
STDMETHOD  GetRawValue , :ptr , :DWORD, :DWORD
STDMETHOD  SetBoolVector , :ptr BOOL
STDMETHOD  SetIntVector , :ptr DWORD
STDMETHOD  SetFloatVector , :ptr REAL4
STDMETHOD  GetBoolVector , :ptr BOOL
STDMETHOD  GetIntVector , :ptr DWORD
STDMETHOD  GetFloatVector , :ptr REAL4
STDMETHOD  SetBoolVectorArray , :ptr BOOL, :DWORD, :DWORD
STDMETHOD  SetIntVectorArray , :ptr DWORD, :DWORD, :DWORD
STDMETHOD  SetFloatVectorArray , :ptr REAL4, :DWORD, :DWORD
STDMETHOD  GetBoolVectorArray , :ptr BOOL, :DWORD, :DWORD
STDMETHOD  GetIntVectorArray , :ptr DWORD, :DWORD, :DWORD
STDMETHOD  GetFloatVectorArray , :ptr REAL4, :DWORD, :DWORD
;}
DECLARE_INTERFACE__END

;//////////////////////////////////////////////////////////////////////////////
;// ID3D10EffectMatrixVariable ////////////////////////////////////////////////
;//////////////////////////////////////////////////////////////////////////////
;ID3D10EffectMatrixVariable typedef ID3D10EffectMatrixVariable

LPD3D10EFFECTMATRIXVARIABLE typedef ptr ID3D10EffectMatrixVariable

;// {50666C24-B82F-4eed-A172-5B6E7E8522E0}
DEFINE_GUID( IID_ID3D10EffectMatrixVariable , 50666c24h , 0b82fh , 4eedh , 0a1h , 72h , 5bh , 6eh , 7eh , 85h , 22h , 0e0h)
;#undef INTERFACE
INTERFACE	EQU	<ID3D10EffectMatrixVariable>
DECLARE_INTERFACE_( ID3D10EffectMatrixVariable , ID3D10EffectVariable)
;{
STDMETHOD_  BOOL , IsValid
STDMETHOD_  ID3D10EffectType * , GetType
STDMETHOD  GetDesc , :ptr D3D10_EFFECT_VARIABLE_DESC
STDMETHOD_  ID3D10EffectVariable * , GetAnnotationByIndex , :DWORD
STDMETHOD_  ID3D10EffectVariable * , GetAnnotationByName , :LPSTR
STDMETHOD_  ID3D10EffectVariable * , GetMemberByIndex , :DWORD
STDMETHOD_  ID3D10EffectVariable * , GetMemberByName , :LPSTR
STDMETHOD_  ID3D10EffectVariable * , GetMemberBySemantic , :LPSTR
STDMETHOD_  ID3D10EffectVariable * , GetElement , :DWORD
STDMETHOD_  ID3D10EffectConstantBuffer * , GetParentConstantBuffer
STDMETHOD_  ID3D10EffectScalarVariable * , AsScalar
STDMETHOD_  ID3D10EffectVectorVariable * , AsVector
STDMETHOD_  ID3D10EffectMatrixVariable * , AsMatrix
STDMETHOD_  ID3D10EffectStringVariable * , AsString
STDMETHOD_  ID3D10EffectShaderResourceVariable * , AsShaderResource
STDMETHOD_  ID3D10EffectRenderTargetViewVariable * , AsRenderTargetView
STDMETHOD_  ID3D10EffectDepthStencilViewVariable * , AsDepthStencilView
STDMETHOD_  ID3D10EffectConstantBuffer * , AsConstantBuffer
STDMETHOD_  ID3D10EffectShaderVariable * , AsShader
STDMETHOD_  ID3D10EffectBlendVariable * , AsBlend
STDMETHOD_  ID3D10EffectDepthStencilVariable * , AsDepthStencil
STDMETHOD_  ID3D10EffectRasterizerVariable * , AsRasterizer
STDMETHOD_  ID3D10EffectSamplerVariable * , AsSampler
STDMETHOD  SetRawValue , :ptr , :DWORD, :DWORD
STDMETHOD  GetRawValue , :ptr , :DWORD, :DWORD
STDMETHOD  SetMatrix , :ptr REAL4
STDMETHOD  GetMatrix , :ptr REAL4
STDMETHOD  SetMatrixArray , :ptr REAL4, :DWORD, :DWORD
STDMETHOD  GetMatrixArray , :ptr REAL4, :DWORD, :DWORD
STDMETHOD  SetMatrixTranspose , :ptr REAL4
STDMETHOD  GetMatrixTranspose , :ptr REAL4
STDMETHOD  SetMatrixTransposeArray , :ptr REAL4, :DWORD, :DWORD
STDMETHOD  GetMatrixTransposeArray , :ptr REAL4, :DWORD, :DWORD
;}
DECLARE_INTERFACE__END

;//////////////////////////////////////////////////////////////////////////////
;// ID3D10EffectStringVariable ////////////////////////////////////////////////
;//////////////////////////////////////////////////////////////////////////////
;ID3D10EffectStringVariable typedef ID3D10EffectStringVariable

LPD3D10EFFECTSTRINGVARIABLE typedef ptr ID3D10EffectStringVariable

;// {71417501-8DF9-4e0a-A78A-255F9756BAFF}
DEFINE_GUID( IID_ID3D10EffectStringVariable , 71417501h , 8df9h , 4e0ah , 0a7h , 8ah , 25h , 5fh , 97h , 56h , 0bah , 0ffh)
;#undef INTERFACE
INTERFACE	EQU	<ID3D10EffectStringVariable>
DECLARE_INTERFACE_( ID3D10EffectStringVariable , ID3D10EffectVariable)
;{
STDMETHOD_  BOOL , IsValid
STDMETHOD_  ID3D10EffectType * , GetType
STDMETHOD  GetDesc , :ptr D3D10_EFFECT_VARIABLE_DESC
STDMETHOD_  ID3D10EffectVariable * , GetAnnotationByIndex , :DWORD
STDMETHOD_  ID3D10EffectVariable * , GetAnnotationByName , :LPSTR
STDMETHOD_  ID3D10EffectVariable * , GetMemberByIndex , :DWORD
STDMETHOD_  ID3D10EffectVariable * , GetMemberByName , :LPSTR
STDMETHOD_  ID3D10EffectVariable * , GetMemberBySemantic , :LPSTR
STDMETHOD_  ID3D10EffectVariable * , GetElement , :DWORD
STDMETHOD_  ID3D10EffectConstantBuffer * , GetParentConstantBuffer
STDMETHOD_  ID3D10EffectScalarVariable * , AsScalar
STDMETHOD_  ID3D10EffectVectorVariable * , AsVector
STDMETHOD_  ID3D10EffectMatrixVariable * , AsMatrix
STDMETHOD_  ID3D10EffectStringVariable * , AsString
STDMETHOD_  ID3D10EffectShaderResourceVariable * , AsShaderResource
STDMETHOD_  ID3D10EffectRenderTargetViewVariable * , AsRenderTargetView
STDMETHOD_  ID3D10EffectDepthStencilViewVariable * , AsDepthStencilView
STDMETHOD_  ID3D10EffectConstantBuffer * , AsConstantBuffer
STDMETHOD_  ID3D10EffectShaderVariable * , AsShader
STDMETHOD_  ID3D10EffectBlendVariable * , AsBlend
STDMETHOD_  ID3D10EffectDepthStencilVariable * , AsDepthStencil
STDMETHOD_  ID3D10EffectRasterizerVariable * , AsRasterizer
STDMETHOD_  ID3D10EffectSamplerVariable * , AsSampler
STDMETHOD  SetRawValue , :ptr , :DWORD, :DWORD
STDMETHOD  GetRawValue , :ptr , :DWORD, :DWORD
STDMETHOD  GetString , :ptr LPSTR
STDMETHOD  GetStringArray , :ptr LPSTR, :DWORD, :DWORD
;}
DECLARE_INTERFACE__END

;//////////////////////////////////////////////////////////////////////////////
;// ID3D10EffectShaderResourceVariable ////////////////////////////////////////
;//////////////////////////////////////////////////////////////////////////////
;ID3D10EffectShaderResourceVariable typedef ID3D10EffectShaderResourceVariable

LPD3D10EFFECTSHADERRESOURCEVARIABLE typedef ptr ID3D10EffectShaderResourceVariable

;// {C0A7157B-D872-4b1d-8073-EFC2ACD4B1FC}
DEFINE_GUID( IID_ID3D10EffectShaderResourceVariable , 0c0a7157bh , 0d872h , 4b1dh , 80h , 73h , 0efh , 0c2h , 0ach , 0d4h , 0b1h , 0fch)
;#undef INTERFACE
INTERFACE	EQU	<ID3D10EffectShaderResourceVariable>
DECLARE_INTERFACE_( ID3D10EffectShaderResourceVariable , ID3D10EffectVariable)
;{
STDMETHOD_  BOOL , IsValid
STDMETHOD_  ID3D10EffectType * , GetType
STDMETHOD  GetDesc , :ptr D3D10_EFFECT_VARIABLE_DESC
STDMETHOD_  ID3D10EffectVariable * , GetAnnotationByIndex , :DWORD
STDMETHOD_  ID3D10EffectVariable * , GetAnnotationByName , :LPSTR
STDMETHOD_  ID3D10EffectVariable * , GetMemberByIndex , :DWORD
STDMETHOD_  ID3D10EffectVariable * , GetMemberByName , :LPSTR
STDMETHOD_  ID3D10EffectVariable * , GetMemberBySemantic , :LPSTR
STDMETHOD_  ID3D10EffectVariable * , GetElement , :DWORD
STDMETHOD_  ID3D10EffectConstantBuffer * , GetParentConstantBuffer
STDMETHOD_  ID3D10EffectScalarVariable * , AsScalar
STDMETHOD_  ID3D10EffectVectorVariable * , AsVector
STDMETHOD_  ID3D10EffectMatrixVariable * , AsMatrix
STDMETHOD_  ID3D10EffectStringVariable * , AsString
STDMETHOD_  ID3D10EffectShaderResourceVariable * , AsShaderResource
STDMETHOD_  ID3D10EffectRenderTargetViewVariable * , AsRenderTargetView
STDMETHOD_  ID3D10EffectDepthStencilViewVariable * , AsDepthStencilView
STDMETHOD_  ID3D10EffectConstantBuffer * , AsConstantBuffer
STDMETHOD_  ID3D10EffectShaderVariable * , AsShader
STDMETHOD_  ID3D10EffectBlendVariable * , AsBlend
STDMETHOD_  ID3D10EffectDepthStencilVariable * , AsDepthStencil
STDMETHOD_  ID3D10EffectRasterizerVariable * , AsRasterizer
STDMETHOD_  ID3D10EffectSamplerVariable * , AsSampler
STDMETHOD  SetRawValue , :ptr , :DWORD, :DWORD
STDMETHOD  GetRawValue , :ptr , :DWORD, :DWORD
STDMETHOD  SetResource , :ptr ID3D10ShaderResourceView
STDMETHOD  GetResource , :ptr ptr ID3D10ShaderResourceView
STDMETHOD  SetResourceArray , :ptr ptr ID3D10ShaderResourceView, :DWORD, :DWORD
STDMETHOD  GetResourceArray , :ptr ptr ID3D10ShaderResourceView, :DWORD, :DWORD
;}
DECLARE_INTERFACE__END

;//////////////////////////////////////////////////////////////////////////////
;// ID3D10EffectRenderTargetViewVariable //////////////////////////////////////
;//////////////////////////////////////////////////////////////////////////////
;ID3D10EffectRenderTargetViewVariable typedef ID3D10EffectRenderTargetViewVariable

LPD3D10EFFECTRENDERTARGETVIEWVARIABLE typedef ptr ID3D10EffectRenderTargetViewVariable

;// {28CA0CC3-C2C9-40bb-B57F-67B737122B17}
DEFINE_GUID( IID_ID3D10EffectRenderTargetViewVariable , 28ca0cc3h , 0c2c9h , 40bbh , 0b5h , 7fh , 67h , 0b7h , 37h , 12h , 2bh , 17h)
;#undef INTERFACE
INTERFACE	EQU	<ID3D10EffectRenderTargetViewVariable>
DECLARE_INTERFACE_( ID3D10EffectRenderTargetViewVariable , ID3D10EffectVariable)
;{
STDMETHOD_  BOOL , IsValid
STDMETHOD_  ID3D10EffectType * , GetType
STDMETHOD  GetDesc , :ptr D3D10_EFFECT_VARIABLE_DESC
STDMETHOD_  ID3D10EffectVariable * , GetAnnotationByIndex , :DWORD
STDMETHOD_  ID3D10EffectVariable * , GetAnnotationByName , :LPSTR
STDMETHOD_  ID3D10EffectVariable * , GetMemberByIndex , :DWORD
STDMETHOD_  ID3D10EffectVariable * , GetMemberByName , :LPSTR
STDMETHOD_  ID3D10EffectVariable * , GetMemberBySemantic , :LPSTR
STDMETHOD_  ID3D10EffectVariable * , GetElement , :DWORD
STDMETHOD_  ID3D10EffectConstantBuffer * , GetParentConstantBuffer
STDMETHOD_  ID3D10EffectScalarVariable * , AsScalar
STDMETHOD_  ID3D10EffectVectorVariable * , AsVector
STDMETHOD_  ID3D10EffectMatrixVariable * , AsMatrix
STDMETHOD_  ID3D10EffectStringVariable * , AsString
STDMETHOD_  ID3D10EffectShaderResourceVariable * , AsShaderResource
STDMETHOD_  ID3D10EffectRenderTargetViewVariable * , AsRenderTargetView
STDMETHOD_  ID3D10EffectDepthStencilViewVariable * , AsDepthStencilView
STDMETHOD_  ID3D10EffectConstantBuffer * , AsConstantBuffer
STDMETHOD_  ID3D10EffectShaderVariable * , AsShader
STDMETHOD_  ID3D10EffectBlendVariable * , AsBlend
STDMETHOD_  ID3D10EffectDepthStencilVariable * , AsDepthStencil
STDMETHOD_  ID3D10EffectRasterizerVariable * , AsRasterizer
STDMETHOD_  ID3D10EffectSamplerVariable * , AsSampler
STDMETHOD  SetRawValue , :ptr , :DWORD, :DWORD
STDMETHOD  GetRawValue , :ptr , :DWORD, :DWORD
STDMETHOD  SetRenderTarget , :ptr ID3D10RenderTargetView
STDMETHOD  GetRenderTarget , :ptr ptr ID3D10RenderTargetView
STDMETHOD  SetRenderTargetArray , :ptr ptr ID3D10RenderTargetView, :DWORD, :DWORD
STDMETHOD  GetRenderTargetArray , :ptr ptr ID3D10RenderTargetView, :DWORD, :DWORD
;}
DECLARE_INTERFACE__END

;//////////////////////////////////////////////////////////////////////////////
;// ID3D10EffectDepthStencilViewVariable //////////////////////////////////////
;//////////////////////////////////////////////////////////////////////////////
;ID3D10EffectDepthStencilViewVariable typedef ID3D10EffectDepthStencilViewVariable

LPD3D10EFFECTDEPTHSTENCILVIEWVARIABLE typedef ptr ID3D10EffectDepthStencilViewVariable

;// {3E02C918-CC79-4985-B622-2D92AD701623}
DEFINE_GUID( IID_ID3D10EffectDepthStencilViewVariable , 3e02c918h , 0cc79h , 4985h , 0b6h , 22h , 2dh , 92h , 0adh , 70h , 16h , 23h)
;#undef INTERFACE
INTERFACE	EQU	<ID3D10EffectDepthStencilViewVariable>
DECLARE_INTERFACE_( ID3D10EffectDepthStencilViewVariable , ID3D10EffectVariable)
;{
STDMETHOD_  BOOL , IsValid
STDMETHOD_  ID3D10EffectType * , GetType
STDMETHOD  GetDesc , :ptr D3D10_EFFECT_VARIABLE_DESC
STDMETHOD_  ID3D10EffectVariable * , GetAnnotationByIndex , :DWORD
STDMETHOD_  ID3D10EffectVariable * , GetAnnotationByName , :LPSTR
STDMETHOD_  ID3D10EffectVariable * , GetMemberByIndex , :DWORD
STDMETHOD_  ID3D10EffectVariable * , GetMemberByName , :LPSTR
STDMETHOD_  ID3D10EffectVariable * , GetMemberBySemantic , :LPSTR
STDMETHOD_  ID3D10EffectVariable * , GetElement , :DWORD
STDMETHOD_  ID3D10EffectConstantBuffer * , GetParentConstantBuffer
STDMETHOD_  ID3D10EffectScalarVariable * , AsScalar
STDMETHOD_  ID3D10EffectVectorVariable * , AsVector
STDMETHOD_  ID3D10EffectMatrixVariable * , AsMatrix
STDMETHOD_  ID3D10EffectStringVariable * , AsString
STDMETHOD_  ID3D10EffectShaderResourceVariable * , AsShaderResource
STDMETHOD_  ID3D10EffectRenderTargetViewVariable * , AsRenderTargetView
STDMETHOD_  ID3D10EffectDepthStencilViewVariable * , AsDepthStencilView
STDMETHOD_  ID3D10EffectConstantBuffer * , AsConstantBuffer
STDMETHOD_  ID3D10EffectShaderVariable * , AsShader
STDMETHOD_  ID3D10EffectBlendVariable * , AsBlend
STDMETHOD_  ID3D10EffectDepthStencilVariable * , AsDepthStencil
STDMETHOD_  ID3D10EffectRasterizerVariable * , AsRasterizer
STDMETHOD_  ID3D10EffectSamplerVariable * , AsSampler
STDMETHOD  SetRawValue , :ptr , :DWORD, :DWORD
STDMETHOD  GetRawValue , :ptr , :DWORD, :DWORD
STDMETHOD  SetDepthStencil , :ptr ID3D10DepthStencilView
STDMETHOD  GetDepthStencil , :ptr ptr ID3D10DepthStencilView
STDMETHOD  SetDepthStencilArray , :ptr ptr ID3D10DepthStencilView, :DWORD, :DWORD
STDMETHOD  GetDepthStencilArray , :ptr ptr ID3D10DepthStencilView, :DWORD, :DWORD
;}
DECLARE_INTERFACE__END

;//////////////////////////////////////////////////////////////////////////////
;// ID3D10EffectConstantBuffer ////////////////////////////////////////////////
;//////////////////////////////////////////////////////////////////////////////
;ID3D10EffectConstantBuffer typedef ID3D10EffectConstantBuffer

LPD3D10EFFECTCONSTANTBUFFER typedef ptr ID3D10EffectConstantBuffer

;// {56648F4D-CC8B-4444-A5AD-B5A3D76E91B3}
DEFINE_GUID( IID_ID3D10EffectConstantBuffer , 56648f4dh , 0cc8bh , 4444h , 0a5h , 0adh , 0b5h , 0a3h , 0d7h , 6eh , 91h , 0b3h)
;#undef INTERFACE
INTERFACE	EQU	<ID3D10EffectConstantBuffer>
DECLARE_INTERFACE_( ID3D10EffectConstantBuffer , ID3D10EffectVariable)
;{
STDMETHOD_  ID3D10EffectType * , GetType
STDMETHOD  GetDesc , :ptr D3D10_EFFECT_VARIABLE_DESC
STDMETHOD_  ID3D10EffectVariable * , GetAnnotationByIndex , :DWORD
STDMETHOD_  ID3D10EffectVariable * , GetAnnotationByName , :LPSTR
STDMETHOD_  ID3D10EffectVariable * , GetMemberByIndex , :DWORD
STDMETHOD_  ID3D10EffectVariable * , GetMemberByName , :LPSTR
STDMETHOD_  ID3D10EffectVariable * , GetMemberBySemantic , :LPSTR
STDMETHOD_  ID3D10EffectVariable * , GetElement , :DWORD
STDMETHOD_  ID3D10EffectConstantBuffer * , GetParentConstantBuffer
STDMETHOD_  ID3D10EffectScalarVariable * , AsScalar
STDMETHOD_  ID3D10EffectVectorVariable * , AsVector
STDMETHOD_  ID3D10EffectMatrixVariable * , AsMatrix
STDMETHOD_  ID3D10EffectStringVariable * , AsString
STDMETHOD_  ID3D10EffectShaderResourceVariable * , AsShaderResource
STDMETHOD_  ID3D10EffectRenderTargetViewVariable * , AsRenderTargetView
STDMETHOD_  ID3D10EffectDepthStencilViewVariable * , AsDepthStencilView
STDMETHOD_  ID3D10EffectConstantBuffer * , AsConstantBuffer
STDMETHOD_  ID3D10EffectShaderVariable * , AsShader
STDMETHOD_  ID3D10EffectBlendVariable * , AsBlend
STDMETHOD_  ID3D10EffectDepthStencilVariable * , AsDepthStencil
STDMETHOD_  ID3D10EffectRasterizerVariable * , AsRasterizer
STDMETHOD_  ID3D10EffectSamplerVariable * , AsSampler
STDMETHOD  SetRawValue , :ptr , :DWORD, :DWORD
STDMETHOD  GetRawValue , :ptr , :DWORD, :DWORD
STDMETHOD  SetConstantBuffer , :ptr ID3D10Buffer
STDMETHOD  GetConstantBuffer , :ptr ptr ID3D10Buffer
STDMETHOD  SetTextureBuffer , :ptr ID3D10ShaderResourceView
STDMETHOD  GetTextureBuffer , :ptr ptr ID3D10ShaderResourceView
;}
DECLARE_INTERFACE__END

;//////////////////////////////////////////////////////////////////////////////
;// ID3D10EffectShaderVariable ////////////////////////////////////////////////
;//////////////////////////////////////////////////////////////////////////////
;//----------------------------------------------------------------------------
;// D3D10_EFFECT_SHADER_DESC:
;//
;// Retrieved by ID3D10EffectShaderVariable::GetShaderDesc()
;//----------------------------------------------------------------------------
D3D10_EFFECT_SHADER_DESC	struct
	pInputSignature			DWORD	?	;// Passed into CreateInputLayout,
										;// valid on VS and GS only
	IsInline					BOOL		?	;// Is this an anonymous shader variable
										;// resulting from an inline shader assignment?
										;// -- The following fields are not valid after Optimize() --
	pBytecode					DWORD	?	;// Shader bytecode
	BytecodeLength				DWORD	?
	SODecl					LPSTR	?	;// Stream out declaration string (for GS with SO)
	NumInputSignatureEntries		DWORD	?	;// Number of entries in the input signature
	NumOutputSignatureEntries	DWORD	?	;// Number of entries in the output signature
D3D10_EFFECT_SHADER_DESC	ends

;ID3D10EffectShaderVariable typedef ID3D10EffectShaderVariable

LPD3D10EFFECTSHADERVARIABLE typedef ptr ID3D10EffectShaderVariable

;// {80849279-C799-4797-8C33-0407A07D9E06}
DEFINE_GUID( IID_ID3D10EffectShaderVariable , 80849279h , 0c799h , 4797h , 8ch , 33h , 4h , 7h , 0a0h , 7dh , 9eh , 6h)
;#undef INTERFACE
INTERFACE	EQU	<ID3D10EffectShaderVariable>
DECLARE_INTERFACE_( ID3D10EffectShaderVariable , ID3D10EffectVariable)
;{
STDMETHOD_  ID3D10EffectType * , GetType
STDMETHOD  GetDesc , :ptr D3D10_EFFECT_VARIABLE_DESC
STDMETHOD_  ID3D10EffectVariable * , GetAnnotationByIndex , :DWORD
STDMETHOD_  ID3D10EffectVariable * , GetAnnotationByName , :LPSTR
STDMETHOD_  ID3D10EffectVariable * , GetMemberByIndex , :DWORD
STDMETHOD_  ID3D10EffectVariable * , GetMemberByName , :LPSTR
STDMETHOD_  ID3D10EffectVariable * , GetMemberBySemantic , :LPSTR
STDMETHOD_  ID3D10EffectVariable * , GetElement , :DWORD
STDMETHOD_  ID3D10EffectConstantBuffer * , GetParentConstantBuffer
STDMETHOD_  ID3D10EffectScalarVariable * , AsScalar
STDMETHOD_  ID3D10EffectVectorVariable * , AsVector
STDMETHOD_  ID3D10EffectMatrixVariable * , AsMatrix
STDMETHOD_  ID3D10EffectStringVariable * , AsString
STDMETHOD_  ID3D10EffectShaderResourceVariable * , AsShaderResource
STDMETHOD_  ID3D10EffectRenderTargetViewVariable * , AsRenderTargetView
STDMETHOD_  ID3D10EffectDepthStencilViewVariable * , AsDepthStencilView
STDMETHOD_  ID3D10EffectConstantBuffer * , AsConstantBuffer
STDMETHOD_  ID3D10EffectShaderVariable * , AsShader
STDMETHOD_  ID3D10EffectBlendVariable * , AsBlend
STDMETHOD_  ID3D10EffectDepthStencilVariable * , AsDepthStencil
STDMETHOD_  ID3D10EffectRasterizerVariable * , AsRasterizer
STDMETHOD_  ID3D10EffectSamplerVariable * , AsSampler
STDMETHOD  SetRawValue , :ptr , :DWORD, :DWORD
STDMETHOD  GetRawValue , :ptr , :DWORD, :DWORD
STDMETHOD  GetShaderDesc , :DWORD, :ptr D3D10_EFFECT_SHADER_DESC
STDMETHOD  GetVertexShader , :DWORD, :ptr ptr ID3D10VertexShader
STDMETHOD  GetGeometryShader , :DWORD, :ptr ptr ID3D10GeometryShader
STDMETHOD  GetPixelShader , :DWORD, :ptr ptr ID3D10PixelShader
STDMETHOD  GetInputSignatureElementDesc , :DWORD, :DWORD, :ptr D3D10_SIGNATURE_PARAMETER_DESC
STDMETHOD  GetOutputSignatureElementDesc , :DWORD, :DWORD, :ptr D3D10_SIGNATURE_PARAMETER_DESC
;}
DECLARE_INTERFACE__END

;//////////////////////////////////////////////////////////////////////////////
;// ID3D10EffectBlendVariable /////////////////////////////////////////////////
;//////////////////////////////////////////////////////////////////////////////
;ID3D10EffectBlendVariable typedef ID3D10EffectBlendVariable

LPD3D10EFFECTBLENDVARIABLE typedef ptr ID3D10EffectBlendVariable

;// {1FCD2294-DF6D-4eae-86B3-0E9160CFB07B}
DEFINE_GUID( IID_ID3D10EffectBlendVariable , 1fcd2294h , 0df6dh , 4eaeh , 86h , 0b3h , 0eh , 91h , 60h , 0cfh , 0b0h , 7bh)
;#undef INTERFACE
INTERFACE	EQU	<ID3D10EffectBlendVariable>
DECLARE_INTERFACE_( ID3D10EffectBlendVariable , ID3D10EffectVariable)
;{
STDMETHOD_  ID3D10EffectType * , GetType
STDMETHOD  GetDesc , :ptr D3D10_EFFECT_VARIABLE_DESC
STDMETHOD_  ID3D10EffectVariable * , GetAnnotationByIndex , :DWORD
STDMETHOD_  ID3D10EffectVariable * , GetAnnotationByName , :LPSTR
STDMETHOD_  ID3D10EffectVariable * , GetMemberByIndex , :DWORD
STDMETHOD_  ID3D10EffectVariable * , GetMemberByName , :LPSTR
STDMETHOD_  ID3D10EffectVariable * , GetMemberBySemantic , :LPSTR
STDMETHOD_  ID3D10EffectVariable * , GetElement , :DWORD
STDMETHOD_  ID3D10EffectConstantBuffer * , GetParentConstantBuffer
STDMETHOD_  ID3D10EffectScalarVariable * , AsScalar
STDMETHOD_  ID3D10EffectVectorVariable * , AsVector
STDMETHOD_  ID3D10EffectMatrixVariable * , AsMatrix
STDMETHOD_  ID3D10EffectStringVariable * , AsString
STDMETHOD_  ID3D10EffectShaderResourceVariable * , AsShaderResource
STDMETHOD_  ID3D10EffectRenderTargetViewVariable * , AsRenderTargetView
STDMETHOD_  ID3D10EffectDepthStencilViewVariable * , AsDepthStencilView
STDMETHOD_  ID3D10EffectConstantBuffer * , AsConstantBuffer
STDMETHOD_  ID3D10EffectShaderVariable * , AsShader
STDMETHOD_  ID3D10EffectBlendVariable * , AsBlend
STDMETHOD_  ID3D10EffectDepthStencilVariable * , AsDepthStencil
STDMETHOD_  ID3D10EffectRasterizerVariable * , AsRasterizer
STDMETHOD_  ID3D10EffectSamplerVariable * , AsSampler
STDMETHOD  SetRawValue , :ptr , :DWORD, :DWORD
STDMETHOD  GetRawValue , :ptr , :DWORD, :DWORD
STDMETHOD  GetBlendState , :DWORD, :ptr ptr ID3D10BlendState
STDMETHOD  GetBackingStore , :DWORD, :ptr D3D10_BLEND_DESC
;}
DECLARE_INTERFACE__END

;//////////////////////////////////////////////////////////////////////////////
;// ID3D10EffectDepthStencilVariable //////////////////////////////////////////
;//////////////////////////////////////////////////////////////////////////////
;ID3D10EffectDepthStencilVariable typedef ID3D10EffectDepthStencilVariable

LPD3D10EFFECTDEPTHSTENCILVARIABLE typedef ptr ID3D10EffectDepthStencilVariable

;// {AF482368-330A-46a5-9A5C-01C71AF24C8D}
DEFINE_GUID( IID_ID3D10EffectDepthStencilVariable , 0af482368h , 330ah , 46a5h , 9ah , 5ch , 1h , 0c7h , 1ah , 0f2h , 4ch , 8dh)
;#undef INTERFACE
INTERFACE	EQU	<ID3D10EffectDepthStencilVariable>
DECLARE_INTERFACE_( ID3D10EffectDepthStencilVariable , ID3D10EffectVariable)
;{
STDMETHOD_  ID3D10EffectType * , GetType
STDMETHOD  GetDesc , :ptr D3D10_EFFECT_VARIABLE_DESC
STDMETHOD_  ID3D10EffectVariable * , GetAnnotationByIndex , :DWORD
STDMETHOD_  ID3D10EffectVariable * , GetAnnotationByName , :LPSTR
STDMETHOD_  ID3D10EffectVariable * , GetMemberByIndex , :DWORD
STDMETHOD_  ID3D10EffectVariable * , GetMemberByName , :LPSTR
STDMETHOD_  ID3D10EffectVariable * , GetMemberBySemantic , :LPSTR
STDMETHOD_  ID3D10EffectVariable * , GetElement , :DWORD
STDMETHOD_  ID3D10EffectConstantBuffer * , GetParentConstantBuffer
STDMETHOD_  ID3D10EffectScalarVariable * , AsScalar
STDMETHOD_  ID3D10EffectVectorVariable * , AsVector
STDMETHOD_  ID3D10EffectMatrixVariable * , AsMatrix
STDMETHOD_  ID3D10EffectStringVariable * , AsString
STDMETHOD_  ID3D10EffectShaderResourceVariable * , AsShaderResource
STDMETHOD_  ID3D10EffectRenderTargetViewVariable * , AsRenderTargetView
STDMETHOD_  ID3D10EffectDepthStencilViewVariable * , AsDepthStencilView
STDMETHOD_  ID3D10EffectConstantBuffer * , AsConstantBuffer
STDMETHOD_  ID3D10EffectShaderVariable * , AsShader
STDMETHOD_  ID3D10EffectBlendVariable * , AsBlend
STDMETHOD_  ID3D10EffectDepthStencilVariable * , AsDepthStencil
STDMETHOD_  ID3D10EffectRasterizerVariable * , AsRasterizer
STDMETHOD_  ID3D10EffectSamplerVariable * , AsSampler
STDMETHOD  SetRawValue , :ptr , :DWORD, :DWORD
STDMETHOD  GetRawValue , :ptr , :DWORD, :DWORD
STDMETHOD  GetDepthStencilState , :DWORD, :ptr ptr ID3D10DepthStencilState
STDMETHOD  GetBackingStore , :DWORD, :ptr D3D10_DEPTH_STENCIL_DESC
;}
DECLARE_INTERFACE__END

;//////////////////////////////////////////////////////////////////////////////
;// ID3D10EffectRasterizerVariable ////////////////////////////////////////////
;//////////////////////////////////////////////////////////////////////////////
;ID3D10EffectRasterizerVariable typedef ID3D10EffectRasterizerVariable

LPD3D10EFFECTRASTERIZERVARIABLE typedef ptr ID3D10EffectRasterizerVariable

;// {21AF9F0E-4D94-4ea9-9785-2CB76B8C0B34}
DEFINE_GUID( IID_ID3D10EffectRasterizerVariable , 21af9f0eh , 4d94h , 4ea9h , 97h , 85h , 2ch , 0b7h , 6bh , 8ch , 0bh , 34h)
;#undef INTERFACE
INTERFACE	EQU	<ID3D10EffectRasterizerVariable>
DECLARE_INTERFACE_( ID3D10EffectRasterizerVariable , ID3D10EffectVariable)
;{
STDMETHOD_  ID3D10EffectType * , GetType
STDMETHOD  GetDesc , :ptr D3D10_EFFECT_VARIABLE_DESC
STDMETHOD_  ID3D10EffectVariable * , GetAnnotationByIndex , :DWORD
STDMETHOD_  ID3D10EffectVariable * , GetAnnotationByName , :LPSTR
STDMETHOD_  ID3D10EffectVariable * , GetMemberByIndex , :DWORD
STDMETHOD_  ID3D10EffectVariable * , GetMemberByName , :LPSTR
STDMETHOD_  ID3D10EffectVariable * , GetMemberBySemantic , :LPSTR
STDMETHOD_  ID3D10EffectVariable * , GetElement , :DWORD
STDMETHOD_  ID3D10EffectConstantBuffer * , GetParentConstantBuffer
STDMETHOD_  ID3D10EffectScalarVariable * , AsScalar
STDMETHOD_  ID3D10EffectVectorVariable * , AsVector
STDMETHOD_  ID3D10EffectMatrixVariable * , AsMatrix
STDMETHOD_  ID3D10EffectStringVariable * , AsString
STDMETHOD_  ID3D10EffectShaderResourceVariable * , AsShaderResource
STDMETHOD_  ID3D10EffectRenderTargetViewVariable * , AsRenderTargetView
STDMETHOD_  ID3D10EffectDepthStencilViewVariable * , AsDepthStencilView
STDMETHOD_  ID3D10EffectConstantBuffer * , AsConstantBuffer
STDMETHOD_  ID3D10EffectShaderVariable * , AsShader
STDMETHOD_  ID3D10EffectBlendVariable * , AsBlend
STDMETHOD_  ID3D10EffectDepthStencilVariable * , AsDepthStencil
STDMETHOD_  ID3D10EffectRasterizerVariable * , AsRasterizer
STDMETHOD_  ID3D10EffectSamplerVariable * , AsSampler
STDMETHOD  SetRawValue , :ptr , :DWORD, :DWORD
STDMETHOD  GetRawValue , :ptr , :DWORD, :DWORD
STDMETHOD  GetRasterizerState , :DWORD, :ptr ptr ID3D10RasterizerState
STDMETHOD  GetBackingStore , :DWORD, :ptr D3D10_RASTERIZER_DESC
;}
DECLARE_INTERFACE__END

;//////////////////////////////////////////////////////////////////////////////
;// ID3D10EffectSamplerVariable ///////////////////////////////////////////////
;//////////////////////////////////////////////////////////////////////////////
;ID3D10EffectSamplerVariable typedef ID3D10EffectSamplerVariable

LPD3D10EFFECTSAMPLERVARIABLE typedef ptr ID3D10EffectSamplerVariable

;// {6530D5C7-07E9-4271-A418-E7CE4BD1E480}
DEFINE_GUID( IID_ID3D10EffectSamplerVariable , 6530d5c7h , 7e9h , 4271h , 0a4h , 18h , 0e7h , 0ceh , 4bh , 0d1h , 0e4h , 80h)
;#undef INTERFACE
INTERFACE	EQU	<ID3D10EffectSamplerVariable>
DECLARE_INTERFACE_( ID3D10EffectSamplerVariable , ID3D10EffectVariable)
;{
STDMETHOD_  ID3D10EffectType * , GetType
STDMETHOD  GetDesc , :ptr D3D10_EFFECT_VARIABLE_DESC
STDMETHOD_  ID3D10EffectVariable * , GetAnnotationByIndex , :DWORD
STDMETHOD_  ID3D10EffectVariable * , GetAnnotationByName , :LPSTR
STDMETHOD_  ID3D10EffectVariable * , GetMemberByIndex , :DWORD
STDMETHOD_  ID3D10EffectVariable * , GetMemberByName , :LPSTR
STDMETHOD_  ID3D10EffectVariable * , GetMemberBySemantic , :LPSTR
STDMETHOD_  ID3D10EffectVariable * , GetElement , :DWORD
STDMETHOD_  ID3D10EffectConstantBuffer * , GetParentConstantBuffer
STDMETHOD_  ID3D10EffectScalarVariable * , AsScalar
STDMETHOD_  ID3D10EffectVectorVariable * , AsVector
STDMETHOD_  ID3D10EffectMatrixVariable * , AsMatrix
STDMETHOD_  ID3D10EffectStringVariable * , AsString
STDMETHOD_  ID3D10EffectShaderResourceVariable * , AsShaderResource
STDMETHOD_  ID3D10EffectRenderTargetViewVariable * , AsRenderTargetView
STDMETHOD_  ID3D10EffectDepthStencilViewVariable * , AsDepthStencilView
STDMETHOD_  ID3D10EffectConstantBuffer * , AsConstantBuffer
STDMETHOD_  ID3D10EffectShaderVariable * , AsShader
STDMETHOD_  ID3D10EffectBlendVariable * , AsBlend
STDMETHOD_  ID3D10EffectDepthStencilVariable * , AsDepthStencil
STDMETHOD_  ID3D10EffectRasterizerVariable * , AsRasterizer
STDMETHOD_  ID3D10EffectSamplerVariable * , AsSampler
STDMETHOD  SetRawValue , :ptr , :DWORD, :DWORD
STDMETHOD  GetRawValue , :ptr , :DWORD, :DWORD
STDMETHOD  GetSampler , :DWORD, :ptr ptr ID3D10SamplerState
STDMETHOD  GetBackingStore , :DWORD, :ptr D3D10_SAMPLER_DESC
;}
DECLARE_INTERFACE__END

;//////////////////////////////////////////////////////////////////////////////
;// ID3D10EffectPass //////////////////////////////////////////////////////////
;//////////////////////////////////////////////////////////////////////////////
;//----------------------------------------------------------------------------
;// D3D10_PASS_DESC:
;//
;// Retrieved by ID3D10EffectPass::GetDesc()
;//----------------------------------------------------------------------------
D3D10_PASS_DESC	struct
	Name_				LPSTR	?		;// Name of this pass (NULL if not anonymous)
	Annotations			DWORD	?		;// Number of annotations on this pass
	pIAInputSignature		DWORD	?		;// Signature from VS or GS (if there is no VS)
										;// or NULL if neither exists
	IAInputSignatureSize	DWORD	?		;// Singature size in bytes
	StencilRef			DWORD	?		;// Specified in SetDepthStencilState()
	SampleMask			DWORD	?		;// Specified in SetBlendState()
	BlendFactor			REAL4 4 dup (?)	;// Specified in SetBlendState()
D3D10_PASS_DESC	ends

;//----------------------------------------------------------------------------
;// D3D10_PASS_SHADER_DESC:
;//
;// Retrieved by ID3D10EffectPass::Get**ShaderDesc()
;//----------------------------------------------------------------------------
D3D10_PASS_SHADER_DESC	struct
	pShaderVariable	DWORD	?	;// The variable that this shader came from.
								;// If this is an inline shader assignment,
								;//   the returned interface will be an
								;//   anonymous shader variable, which is
								;//   not retrievable any other way.  It's
								;//   name in the variable description will
								;//   be "$Anonymous".
								;// If there is no assignment of this type in
								;//   the pass block, pShaderVariable != NULL,
								;//   but pShaderVariable->IsValid() == FALSE.
	ShaderIndex		DWORD	?	;// The element of pShaderVariable (if an array)
								;// or 0 if not applicable
D3D10_PASS_SHADER_DESC	ends

;ID3D10EffectPass typedef ID3D10EffectPass

LPD3D10EFFECTPASS typedef ptr ID3D10EffectPass

;// {5CFBEB89-1A06-46e0-B282-E3F9BFA36A54}
DEFINE_GUID( IID_ID3D10EffectPass , 5cfbeb89h , 1a06h , 46e0h , 0b2h , 82h , 0e3h , 0f9h , 0bfh , 0a3h , 6ah , 54h)
;#undef INTERFACE
INTERFACE	EQU	<ID3D10EffectPass>
DECLARE_INTERFACE( ID3D10EffectPass)
;{
STDMETHOD_  BOOL , IsValid
STDMETHOD  GetDesc , :ptr D3D10_PASS_DESC
STDMETHOD  GetVertexShaderDesc , :ptr D3D10_PASS_SHADER_DESC
STDMETHOD  GetGeometryShaderDesc , :ptr D3D10_PASS_SHADER_DESC
STDMETHOD  GetPixelShaderDesc , :ptr D3D10_PASS_SHADER_DESC
STDMETHOD_  ID3D10EffectVariable * , GetAnnotationByIndex , :DWORD
STDMETHOD_  ID3D10EffectVariable * , GetAnnotationByName , :LPSTR
STDMETHOD  Apply , :DWORD
STDMETHOD  ComputeStateBlockMask , :ptr D3D10_STATE_BLOCK_MASK
;}
DECLARE_INTERFACE_END

;//////////////////////////////////////////////////////////////////////////////
;// ID3D10EffectTechnique /////////////////////////////////////////////////////
;//////////////////////////////////////////////////////////////////////////////
;//----------------------------------------------------------------------------
;// D3D10_TECHNIQUE_DESC:
;//
;// Retrieved by ID3D10EffectTechnique::GetDesc()
;//----------------------------------------------------------------------------
D3D10_TECHNIQUE_DESC	struct
	Name_		LPSTR	?	;// Name of this technique (NULL if not anonymous)
	Passes		DWORD	?	;// Number of passes contained within
	Annotations	DWORD	?	;// Number of annotations on this technique
D3D10_TECHNIQUE_DESC	ends

;ID3D10EffectTechnique typedef ID3D10EffectTechnique

LPD3D10EFFECTTECHNIQUE typedef ptr ID3D10EffectTechnique

;// {DB122CE8-D1C9-4292-B237-24ED3DE8B175}
DEFINE_GUID( IID_ID3D10EffectTechnique , 0db122ce8h , 0d1c9h , 4292h , 0b2h , 37h , 24h , 0edh , 3dh , 0e8h , 0b1h , 75h)
;#undef INTERFACE
INTERFACE	EQU	<ID3D10EffectTechnique>
DECLARE_INTERFACE( ID3D10EffectTechnique)
;{
STDMETHOD_  BOOL , IsValid
STDMETHOD  GetDesc , :ptr D3D10_TECHNIQUE_DESC
STDMETHOD_  ID3D10EffectVariable * , GetAnnotationByIndex , :DWORD
STDMETHOD_  ID3D10EffectVariable * , GetAnnotationByName , :LPSTR
STDMETHOD_  ID3D10EffectPass * , GetPassByIndex , :DWORD
STDMETHOD_  ID3D10EffectPass * , GetPassByName , :LPSTR
STDMETHOD  ComputeStateBlockMask , :ptr D3D10_STATE_BLOCK_MASK
;}
DECLARE_INTERFACE_END

;//////////////////////////////////////////////////////////////////////////////
;// ID3D10Effect //////////////////////////////////////////////////////////////
;//////////////////////////////////////////////////////////////////////////////
;//----------------------------------------------------------------------------
;// D3D10_EFFECT_DESC:
;//
;// Retrieved by ID3D10Effect::GetDesc()
;//----------------------------------------------------------------------------
D3D10_EFFECT_DESC	struct
	IsChildEffect			BOOL		?	;// TRUE if this is a child effect,
									;// FALSE if this is standalone or an effect pool.
	ConstantBuffers		DWORD	?	;// Number of constant buffers in this effect,
									;// excluding the effect pool.
	SharedConstantBuffers	DWORD	?	;// Number of constant buffers shared in this
									;// effect's pool.
	GlobalVariables		DWORD	?	;// Number of global variables in this effect,
									;// excluding the effect pool.
	SharedGlobalVariables	DWORD	?	;// Number of global variables shared in this
									;// effect's pool.
	Techniques			DWORD	?	;// Number of techniques in this effect,
									;// excluding the effect pool.
D3D10_EFFECT_DESC	ends

;ID3D10Effect typedef ID3D10Effect

LPD3D10EFFECT typedef ptr ID3D10Effect

;// {51B0CA8B-EC0B-4519-870D-8EE1CB5017C7}
DEFINE_GUID( IID_ID3D10Effect , 51b0ca8bh , 0ec0bh , 4519h , 87h , 0dh , 8eh , 0e1h , 0cbh , 50h , 17h , 0c7h)
;#undef INTERFACE
INTERFACE	EQU	<ID3D10Effect>
DECLARE_INTERFACE_( ID3D10Effect , IUnknown)
;{
;// IUnknown
STDMETHOD  QueryInterface , :REFIID, :ptr LPVOID
STDMETHOD_  ULONG , AddRef
STDMETHOD_  ULONG , Release
STDMETHOD_  BOOL , IsValid
STDMETHOD_  BOOL , IsPool
;// Managing D3D Device
STDMETHOD  GetDevice , :ptr ptr ID3D10Device
;// New Reflection APIs
STDMETHOD  GetDesc , :ptr D3D10_EFFECT_DESC
STDMETHOD_  ID3D10EffectConstantBuffer * , GetConstantBufferByIndex , :DWORD
STDMETHOD_  ID3D10EffectConstantBuffer * , GetConstantBufferByName , :LPSTR
STDMETHOD_  ID3D10EffectVariable * , GetVariableByIndex , :DWORD
STDMETHOD_  ID3D10EffectVariable * , GetVariableByName , :LPSTR
STDMETHOD_  ID3D10EffectVariable * , GetVariableBySemantic , :LPSTR
STDMETHOD_  ID3D10EffectTechnique * , GetTechniqueByIndex , :DWORD
STDMETHOD_  ID3D10EffectTechnique * , GetTechniqueByName , :LPSTR
STDMETHOD  Optimize
STDMETHOD_  BOOL , IsOptimized
;}
DECLARE_INTERFACE__END

;//////////////////////////////////////////////////////////////////////////////
;// ID3D10EffectPool //////////////////////////////////////////////////////////
;//////////////////////////////////////////////////////////////////////////////
;ID3D10EffectPool typedef ID3D10EffectPool

LPD3D10EFFECTPOOL typedef ptr ID3D10EffectPool

;// {9537AB04-3250-412e-8213-FCD2F8677933}
DEFINE_GUID( IID_ID3D10EffectPool , 9537ab04h , 3250h , 412eh , 82h , 13h , 0fch , 0d2h , 0f8h , 67h , 79h , 33h)
;#undef INTERFACE
INTERFACE	EQU	<ID3D10EffectPool>
DECLARE_INTERFACE_( ID3D10EffectPool , IUnknown)
;{
;// IUnknown
STDMETHOD  QueryInterface , :REFIID, :ptr LPVOID
STDMETHOD_  ULONG , AddRef
STDMETHOD_  ULONG , Release
STDMETHOD_  ID3D10Effect * , AsEffect
;// No public methods
;}
DECLARE_INTERFACE__END

;//////////////////////////////////////////////////////////////////////////////
;// APIs //////////////////////////////////////////////////////////////////////
;//////////////////////////////////////////////////////////////////////////////
ifdef __cplusplus
;extern "C"
;{
endif ;//__cplusplus
;//----------------------------------------------------------------------------
;// D3D10CreateEffectFromXXXX:
;// --------------------------
;// Creates an effect from a binary effect or file
;//
;// Parameters:
;//
;// [in]
;//
;//
;//  pData
;//      Blob of effect data, either ASCII (uncompiled, for D3D10CompileEffectFromMemory) or binary (compiled, for D3D10CreateEffect*)
;//  DataLength
;//      Length of the data blob
;//
;//  pSrcFileName
;//      Name of the ASCII Effect file pData was obtained from
;//
;//  pDefines
;//      Optional NULL-terminated array of preprocessor macro definitions.
;//  pInclude
;//      Optional interface pointer to use for handling #include directives.
;//      If this parameter is NULL, #includes will be honored when compiling
;//      from file, and will error when compiling from resource or memory.
;//  HLSLFlags
;//      Compilation flags pertaining to shaders and data types, honored by
;//      the HLSL compiler
;//  FXFlags
;//      Compilation flags pertaining to Effect compilation, honored
;//      by the Effect compiler
;//  pDevice
;//      Pointer to the D3D10 device on which to create Effect resources
;//  pEffectPool
;//      Pointer to an Effect pool to share variables with or NULL
;//
;// [out]
;//
;//  ppEffect
;//      Address of the newly created Effect interface
;//  ppEffectPool
;//      Address of the newly created Effect pool interface
;//  ppErrors
;//      If non-NULL, address of a buffer with error messages that occurred
;//      during parsing or compilation
;//
;//----------------------------------------------------------------------------
D3D10CompileEffectFromMemory proto WINSTDCALLCONV :ptr , :DWORD, :LPSTR, :ptr D3D10_SHADER_MACRO, :ptr ID3D10Include, :DWORD, :DWORD, :ptr ptr ID3D10Blob, :ptr ptr ID3D10Blob
D3D10CreateEffectFromMemory proto WINSTDCALLCONV :ptr , :DWORD, :DWORD, :ptr ID3D10Device, :ptr ID3D10EffectPool, :ptr ptr ID3D10Effect
D3D10CreateEffectPoolFromMemory proto WINSTDCALLCONV :ptr , :DWORD, :DWORD, :ptr ID3D10Device, :ptr ptr ID3D10EffectPool
;//----------------------------------------------------------------------------
;// D3D10DisassembleEffect:
;// -----------------------
;// Takes an effect interface, and returns a buffer containing text assembly.
;//
;// Parameters:
;//  pEffect
;//      Pointer to the runtime effect interface.
;//  EnableColorCode
;//      Emit HTML tags for color coding the output?
;//  ppDisassembly
;//      Returns a buffer containing the disassembled effect.
;//----------------------------------------------------------------------------
D3D10DisassembleEffect proto WINSTDCALLCONV :ptr ID3D10Effect, :BOOL, :ptr ptr ID3D10Blob
ifdef __cplusplus
;}
endif ;//__cplusplus
endif ;//__D3D10EFFECT_H__

;--- warnings: 4
;--- errors: 0
;--- end of file ---
