;--- include file created by h2incx v0.99.20 (copyright 2005-2009 japheth)
;--- source file: C:\Program Files\Microsoft SDKs\Windows\v7.1\Include\d3d10shader.h, last modified: 4/19/2010 21:44
;--- cmdline used for creation:  -v -W3  -c -i -y -d3 -r -I "C:\Program Files (x86)\Microsoft Visual Studio 10.0\VC\include" -o "E:\Eigene Dateien\Dokumente\H2IncX\DX11" "C:\Program Files\Microsoft SDKs\Windows\v7.1\Include\d3d11.h"

;//////////////////////////////////////////////////////////////////////////////
;//
;//  Copyright (c) Microsoft Corporation.  All rights reserved.
;//
;//  File:       D3D10Shader.h
;//  Content:    D3D10 Shader Types and APIs
;//
;//////////////////////////////////////////////////////////////////////////////
ifndef __D3D10SHADER_H__
__D3D10SHADER_H__	EQU	<>
	include d3d10.inc
;//---------------------------------------------------------------------------
;// D3D10_TX_VERSION:
;// --------------
;// Version token used to create a procedural texture filler in effects
;// Used by D3D10Fill[]TX functions
;//---------------------------------------------------------------------------
D3D10_TX_VERSION macro _Major,_Minor
	exitm <( ( 'T'  shl  24 )  or  ( 'X'  shl  16 )  or  ( ( _Major )  shl  8 )  or  ( _Minor ) ) >
	endm
;//----------------------------------------------------------------------------
;// D3D10SHADER flags:
;// -----------------
;// D3D10_SHADER_DEBUG
;//   Insert debug file/line/type/symbol information.
;//
;// D3D10_SHADER_SKIP_VALIDATION
;//   Do not validate the generated code against known capabilities and
;//   constraints.  This option is only recommended when compiling shaders
;//   you KNOW will work.  (ie. have compiled before without this option.)
;//   Shaders are always validated by D3D before they are set to the device.
;//
;// D3D10_SHADER_SKIP_OPTIMIZATION
;//   Instructs the compiler to skip optimization steps during code generation.
;//   Unless you are trying to isolate a problem in your code using this option
;//   is not recommended.
;//
;// D3D10_SHADER_PACK_MATRIX_ROW_MAJOR
;//   Unless explicitly specified, matrices will be packed in row-major order
;//   on input and output from the shader.
;//
;// D3D10_SHADER_PACK_MATRIX_COLUMN_MAJOR
;//   Unless explicitly specified, matrices will be packed in column-major
;//   order on input and output from the shader.  This is generally more
;//   efficient, since it allows vector-matrix multiplication to be performed
;//   using a series of dot-products.
;//
;// D3D10_SHADER_PARTIAL_PRECISION
;//   Force all computations in resulting shader to occur at partial precision.
;//   This may result in faster evaluation of shaders on some hardware.
;//
;// D3D10_SHADER_FORCE_VS_SOFTWARE_NO_OPT
;//   Force compiler to compile against the next highest available software
;//   target for vertex shaders.  This flag also turns optimizations off,
;//   and debugging on.
;//
;// D3D10_SHADER_FORCE_PS_SOFTWARE_NO_OPT
;//   Force compiler to compile against the next highest available software
;//   target for pixel shaders.  This flag also turns optimizations off,
;//   and debugging on.
;//
;// D3D10_SHADER_NO_PRESHADER
;//   Disables Preshaders. Using this flag will cause the compiler to not
;//   pull out static expression for evaluation on the host cpu
;//
;// D3D10_SHADER_AVOID_FLOW_CONTROL
;//   Hint compiler to avoid flow-control constructs where possible.
;//
;// D3D10_SHADER_PREFER_FLOW_CONTROL
;//   Hint compiler to prefer flow-control constructs where possible.
;//
;// D3D10_SHADER_ENABLE_STRICTNESS
;//   By default, the HLSL/Effect compilers are not strict on deprecated syntax.
;//   Specifying this flag enables the strict mode. Deprecated syntax may be
;//   removed in a future release, and enabling syntax is a good way to make sure
;//   your shaders comply to the latest spec.
;//
;// D3D10_SHADER_ENABLE_BACKWARDS_COMPATIBILITY
;//   This enables older shaders to compile to 4_0 targets.
;//
;//----------------------------------------------------------------------------
D3D10_SHADER_DEBUG						EQU	( 1  shl  0 )
D3D10_SHADER_SKIP_VALIDATION				EQU	( 1  shl  1 )
D3D10_SHADER_SKIP_OPTIMIZATION			EQU	( 1  shl  2 )
D3D10_SHADER_PACK_MATRIX_ROW_MAJOR			EQU	( 1  shl  3 )
D3D10_SHADER_PACK_MATRIX_COLUMN_MAJOR		EQU	( 1  shl  4 )
D3D10_SHADER_PARTIAL_PRECISION			EQU	( 1  shl  5 )
D3D10_SHADER_FORCE_VS_SOFTWARE_NO_OPT		EQU	( 1  shl  6 )
D3D10_SHADER_FORCE_PS_SOFTWARE_NO_OPT		EQU	( 1  shl  7 )
D3D10_SHADER_NO_PRESHADER				EQU	( 1  shl  8 )
D3D10_SHADER_AVOID_FLOW_CONTROL			EQU	( 1  shl  9 )
D3D10_SHADER_PREFER_FLOW_CONTROL			EQU	( 1  shl  10 )
D3D10_SHADER_ENABLE_STRICTNESS			EQU	( 1  shl  11 )
D3D10_SHADER_ENABLE_BACKWARDS_COMPATIBILITY	EQU	( 1  shl  12 )
D3D10_SHADER_IEEE_STRICTNESS				EQU	( 1  shl  13 )
D3D10_SHADER_WARNINGS_ARE_ERRORS			EQU	( 1  shl  18 )
;// optimization level flags
D3D10_SHADER_OPTIMIZATION_LEVEL0			EQU	( 1  shl  14 )
D3D10_SHADER_OPTIMIZATION_LEVEL1			EQU	0
D3D10_SHADER_OPTIMIZATION_LEVEL2			EQU	( ( 1  shl  14 )  or  ( 1  shl  15 ) )
D3D10_SHADER_OPTIMIZATION_LEVEL3			EQU	( 1  shl  15 )
;//----------------------------------------------------------------------------
;// D3D10_SHADER_MACRO:
;// ----------
;// Preprocessor macro definition.  The application pass in a NULL-terminated
;// array of this structure to various D3D10 APIs.  This enables the application
;// to #define tokens at runtime, before the file is parsed.
;//----------------------------------------------------------------------------
D3D10_SHADER_MACRO	struct
	Name_		LPSTR	?
	Definition	LPSTR	?
D3D10_SHADER_MACRO	ends
LPD3D10_SHADER_MACRO typedef ptr D3D10_SHADER_MACRO

;//----------------------------------------------------------------------------
;// D3D10_SHADER_VARIABLE_CLASS:
;//----------------------------------------------------------------------------
D3D10_SHADER_VARIABLE_CLASS typedef DWORD
D3D10_SVC_SCALAR = 0
D3D10_SVC_VECTOR = 1
D3D10_SVC_MATRIX_ROWS = 2
D3D10_SVC_MATRIX_COLUMNS = 3
D3D10_SVC_OBJECT = 4
D3D10_SVC_STRUCT = 5
D3D11_SVC_INTERFACE_CLASS = 6
D3D11_SVC_INTERFACE_POINTER = 7
;// force 32-bit size enum
D3D10_SVC_FORCE_DWORD = 7fffffffh

LPD3D10_SHADER_VARIABLE_CLASS typedef ptr D3D10_SHADER_VARIABLE_CLASS

D3D10_SHADER_VARIABLE_FLAGS typedef DWORD
D3D10_SVF_USERPACKED = 1
D3D10_SVF_USED = 2
D3D11_SVF_INTERFACE_POINTER = 4
;// force 32-bit size enum
D3D10_SVF_FORCE_DWORD = 7fffffffh

LPD3D10_SHADER_VARIABLE_FLAGS typedef ptr D3D10_SHADER_VARIABLE_FLAGS

;//----------------------------------------------------------------------------
;// D3D10_SHADER_VARIABLE_TYPE:
;//----------------------------------------------------------------------------
D3D10_SHADER_VARIABLE_TYPE typedef DWORD
D3D10_SVT_VOID = 0
D3D10_SVT_BOOL = 1
D3D10_SVT_INT = 2
D3D10_SVT_FLOAT = 3
D3D10_SVT_STRING = 4
D3D10_SVT_TEXTURE = 5
D3D10_SVT_TEXTURE1D = 6
D3D10_SVT_TEXTURE2D = 7
D3D10_SVT_TEXTURE3D = 8
D3D10_SVT_TEXTURECUBE = 9
D3D10_SVT_SAMPLER = 10
D3D10_SVT_PIXELSHADER = 15
D3D10_SVT_VERTEXSHADER = 16
D3D10_SVT_UINT = 19
D3D10_SVT_UINT8 = 20
D3D10_SVT_GEOMETRYSHADER = 21
D3D10_SVT_RASTERIZER = 22
D3D10_SVT_DEPTHSTENCIL = 23
D3D10_SVT_BLEND = 24
D3D10_SVT_BUFFER = 25
D3D10_SVT_CBUFFER = 26
D3D10_SVT_TBUFFER = 27
D3D10_SVT_TEXTURE1DARRAY = 28
D3D10_SVT_TEXTURE2DARRAY = 29
D3D10_SVT_RENDERTARGETVIEW = 30
D3D10_SVT_DEPTHSTENCILVIEW = 31
D3D10_SVT_TEXTURE2DMS = 32
D3D10_SVT_TEXTURE2DMSARRAY = 33
D3D10_SVT_TEXTURECUBEARRAY = 34
D3D11_SVT_HULLSHADER = 35
D3D11_SVT_DOMAINSHADER = 36
D3D11_SVT_INTERFACE_POINTER = 37
D3D11_SVT_COMPUTESHADER = 38
D3D11_SVT_DOUBLE = 39
;// force 32-bit size enum
D3D10_SVT_FORCE_DWORD = 7fffffffh

LPD3D10_SHADER_VARIABLE_TYPE typedef ptr D3D10_SHADER_VARIABLE_TYPE

D3D10_SHADER_INPUT_FLAGS typedef DWORD
D3D10_SIF_USERPACKED = 1
D3D10_SIF_COMPARISON_SAMPLER = 2 	;// is this a comparison sampler?
D3D10_SIF_TEXTURE_COMPONENT_0 = 4 	;// this 2-bit value encodes c - 1, where c
D3D10_SIF_TEXTURE_COMPONENT_1 = 8 	;// is the number of components in the texture
D3D10_SIF_TEXTURE_COMPONENTS = 12 	;// force 32-bit size enum
D3D10_SIF_FORCE_DWORD = 7fffffffh

LPD3D10_SHADER_INPUT_FLAGS typedef ptr D3D10_SHADER_INPUT_FLAGS

;//----------------------------------------------------------------------------
;// D3D10_SHADER_INPUT_TYPE
;//----------------------------------------------------------------------------
D3D10_SHADER_INPUT_TYPE typedef DWORD
D3D10_SIT_CBUFFER = 0
D3D10_SIT_TBUFFER = 1
D3D10_SIT_TEXTURE = 2
D3D10_SIT_SAMPLER = 3
D3D11_SIT_UAV_RWTYPED = 4
D3D11_SIT_STRUCTURED = 5
D3D11_SIT_UAV_RWSTRUCTURED = 6
D3D11_SIT_BYTEADDRESS = 7
D3D11_SIT_UAV_RWBYTEADDRESS = 8
D3D11_SIT_UAV_APPEND_STRUCTURED = 9
D3D11_SIT_UAV_CONSUME_STRUCTURED = 10
D3D11_SIT_UAV_RWSTRUCTURED_WITH_COUNTER = 11

LPD3D10_SHADER_INPUT_TYPE typedef ptr D3D10_SHADER_INPUT_TYPE

D3D10_SHADER_CBUFFER_FLAGS typedef DWORD
D3D10_CBF_USERPACKED = 1
;// force 32-bit size enum
D3D10_CBF_FORCE_DWORD = 7fffffffh

LPD3D10_SHADER_CBUFFER_FLAGS typedef ptr D3D10_SHADER_CBUFFER_FLAGS

D3D10_CBUFFER_TYPE typedef DWORD
D3D10_CT_CBUFFER = 0
D3D10_CT_TBUFFER = 1

LPD3D10_CBUFFER_TYPE typedef ptr D3D10_CBUFFER_TYPE

D3D10_NAME typedef DWORD
D3D10_NAME_UNDEFINED = 0
;// Names meaningful to both HLSL and hardware
D3D10_NAME_POSITION = 1
D3D10_NAME_CLIP_DISTANCE = 2
D3D10_NAME_CULL_DISTANCE = 3
D3D10_NAME_RENDER_TARGET_ARRAY_INDEX = 4
D3D10_NAME_VIEWPORT_ARRAY_INDEX = 5
D3D10_NAME_VERTEX_ID = 6
D3D10_NAME_PRIMITIVE_ID = 7
D3D10_NAME_INSTANCE_ID = 8
D3D10_NAME_IS_FRONT_FACE = 9
D3D10_NAME_SAMPLE_INDEX = 10
D3D11_NAME_FINAL_QUAD_EDGE_TESSFACTOR = 11
D3D11_NAME_FINAL_QUAD_INSIDE_TESSFACTOR = 12
D3D11_NAME_FINAL_TRI_EDGE_TESSFACTOR = 13
D3D11_NAME_FINAL_TRI_INSIDE_TESSFACTOR = 14
D3D11_NAME_FINAL_LINE_DETAIL_TESSFACTOR = 15
D3D11_NAME_FINAL_LINE_DENSITY_TESSFACTOR = 16
;// Names meaningful to HLSL only
D3D10_NAME_TARGET = 64
D3D10_NAME_DEPTH = 65
D3D10_NAME_COVERAGE = 66
D3D11_NAME_DEPTH_GREATER_EQUAL = 67
D3D11_NAME_DEPTH_LESS_EQUAL = 68

D3D10_RESOURCE_RETURN_TYPE typedef DWORD
D3D10_RETURN_TYPE_UNORM = 1
D3D10_RETURN_TYPE_SNORM = 2
D3D10_RETURN_TYPE_SINT = 3
D3D10_RETURN_TYPE_UINT = 4
D3D10_RETURN_TYPE_FLOAT = 5
D3D10_RETURN_TYPE_MIXED = 6

D3D10_REGISTER_COMPONENT_TYPE typedef DWORD
D3D10_REGISTER_COMPONENT_UNKNOWN = 0
D3D10_REGISTER_COMPONENT_UINT32 = 1
D3D10_REGISTER_COMPONENT_SINT32 = 2
D3D10_REGISTER_COMPONENT_FLOAT32 = 3

;//----------------------------------------------------------------------------
;// D3D10_INCLUDE_TYPE:
;//----------------------------------------------------------------------------
D3D10_INCLUDE_TYPE typedef DWORD
D3D10_INCLUDE_LOCAL = 0
D3D10_INCLUDE_SYSTEM = 1
;// force 32-bit size enum
D3D10_INCLUDE_FORCE_DWORD = 7fffffffh

LPD3D10_INCLUDE_TYPE typedef ptr D3D10_INCLUDE_TYPE

;//----------------------------------------------------------------------------
;// ID3D10Include:
;// -------------
;// This interface is intended to be implemented by the application, and can
;// be used by various D3D10 APIs.  This enables application-specific handling
;// of #include directives in source files.
;//
;// Open()
;//    Opens an include file.  If successful, it should fill in ppData and
;//    pBytes.  The data pointer returned must remain valid until Close is
;//    subsequently called.  The name of the file is encoded in UTF-8 format.
;// Close()
;//    Closes an include file.  If Open was successful, Close is guaranteed
;//    to be called before the API using this interface returns.
;//----------------------------------------------------------------------------
;ID3D10Include typedef ID3D10Include

LPD3D10INCLUDE typedef ptr ID3D10Include

;#undef INTERFACE
INTERFACE	EQU	<ID3D10Include>
DECLARE_INTERFACE( ID3D10Include)
;{
STDMETHOD  Open , :D3D10_INCLUDE_TYPE, :LPSTR, :LPCVOID, :ptr LPCVOID, :ptr DWORD
STDMETHOD  Close , :LPCVOID
;}
DECLARE_INTERFACE_END

;//----------------------------------------------------------------------------
;// ID3D10ShaderReflection:
;//----------------------------------------------------------------------------
;//
;// Structure definitions
;//
D3D10_SHADER_DESC	struct
	Version					DWORD	?				;// Shader version
	Creator					LPSTR	?				;// Creator string
	Flags					DWORD	?				;// Shader compilation/parse flags
	ConstantBuffers			DWORD	?				;// Number of constant buffers
	BoundResources				DWORD	?				;// Number of bound resources
	InputParameters			DWORD	?				;// Number of parameters in the input signature
	OutputParameters			DWORD	?				;// Number of parameters in the output signature
	InstructionCount			DWORD	?				;// Number of emitted instructions
	TempRegisterCount			DWORD	?				;// Number of temporary registers used
	TempArrayCount				DWORD	?				;// Number of temporary arrays used
	DefCount					DWORD	?				;// Number of constant defines
	DclCount					DWORD	?				;// Number of declarations (input + output)
	TextureNormalInstructions	DWORD	?				;// Number of non-categorized texture instructions
	TextureLoadInstructions		DWORD	?				;// Number of texture load instructions
	TextureCompInstructions		DWORD	?				;// Number of texture comparison instructions
	TextureBiasInstructions		DWORD	?				;// Number of texture bias instructions
	TextureGradientInstructions	DWORD	?				;// Number of texture gradient instructions
	FloatInstructionCount		DWORD	?				;// Number of floating point arithmetic instructions used
	IntInstructionCount			DWORD	?				;// Number of signed integer arithmetic instructions used
	UintInstructionCount		DWORD	?				;// Number of unsigned integer arithmetic instructions used
	StaticFlowControlCount		DWORD	?				;// Number of static flow control instructions used
	DynamicFlowControlCount		DWORD	?				;// Number of dynamic flow control instructions used
	MacroInstructionCount		DWORD	?				;// Number of macro instructions used
	ArrayInstructionCount		DWORD	?				;// Number of array instructions used
	CutInstructionCount			DWORD	?				;// Number of cut instructions used
	EmitInstructionCount		DWORD	?				;// Number of emit instructions used
	GSOutputTopology			D3D10_PRIMITIVE_TOPOLOGY	?	;// Geometry shader output topology
	GSMaxOutputVertexCount		DWORD	?				;// Geometry shader maximum output vertex count
D3D10_SHADER_DESC	ends

D3D10_SHADER_BUFFER_DESC	struct
	Name_	LPSTR	?			;// Name of the constant buffer
	Type_	D3D10_CBUFFER_TYPE	?	;// Indicates that this is a CBuffer or TBuffer
	Variables	DWORD	?			;// Number of member variables
	Size_	DWORD	?			;// Size of CB (in bytes)
	uFlags	DWORD	?			;// Buffer description flags
D3D10_SHADER_BUFFER_DESC	ends

D3D10_SHADER_VARIABLE_DESC	struct
	Name_		LPSTR	?	;// Name of the variable
	StartOffset	DWORD	?	;// Offset in constant buffer's backing store
	Size_		DWORD	?	;// Size of variable (in bytes)
	uFlags		DWORD	?	;// Variable flags
	DefaultValue	LPVOID	?	;// Raw pointer to default value
D3D10_SHADER_VARIABLE_DESC	ends

D3D10_SHADER_TYPE_DESC	struct
	Class	D3D10_SHADER_VARIABLE_CLASS	?	;// Variable class (e.g. object, matrix, etc.)
	Type_	D3D10_SHADER_VARIABLE_TYPE	?	;// Variable type (e.g. float, sampler, etc.)
	Rows		DWORD	?					;// Number of rows (for matrices, 1 for other numeric, 0 if not applicable)
	Columns	DWORD	?					;// Number of columns (for vectors & matrices, 1 for other numeric, 0 if not applicable)
	Elements	DWORD	?					;// Number of elements (0 if not an array)
	Members	DWORD	?					;// Number of members (0 if not a structure)
	Offset_	DWORD	?					;// Offset from the start of structure (0 if not a structure member)
D3D10_SHADER_TYPE_DESC	ends

D3D10_SHADER_INPUT_BIND_DESC	struct
	Name_		LPSTR	?						;// Name of the resource
	Type_		D3D10_SHADER_INPUT_TYPE	?			;// Type of resource (e.g. texture, cbuffer, etc.)
	BindPoint		DWORD	?						;// Starting bind point
	BindCount		DWORD	?						;// Number of contiguous bind points (for arrays)
	uFlags		DWORD	?						;// Input binding flags
	ReturnType	D3D10_RESOURCE_RETURN_TYPE	?		;// Return type (if texture)
	Dimension		D3D10_SRV_DIMENSION	?				;// Dimension (if texture)
	NumSamples	DWORD	?						;// Number of samples (0 if not MS texture)
D3D10_SHADER_INPUT_BIND_DESC	ends

D3D10_SIGNATURE_PARAMETER_DESC	struct
	SemanticName		LPSTR	?						;// Name of the semantic
	SemanticIndex		DWORD	?						;// Index of the semantic
	Register			DWORD	?						;// Number of member variables
	SystemValueType	D3D10_NAME	?					;// A predefined system value, or D3D10_NAME_UNDEFINED if not applicable
	ComponentType		D3D10_REGISTER_COMPONENT_TYPE	?		;// Scalar type (e.g. uint, float, etc.)
	Mask_			BYTE	?							;// Mask to indicate which components of the register
													;// are used (combination of D3D10_COMPONENT_MASK values)
	ReadWriteMask		BYTE	?							;// Mask to indicate whether a given component is
													;// never written (if this is an output signature) or
													;// always read (if this is an input signature).
													;// (combination of D3D10_COMPONENT_MASK values)
D3D10_SIGNATURE_PARAMETER_DESC	ends

;//
;// Interface definitions
;//
;ID3D10ShaderReflectionType typedef ID3D10ShaderReflectionType

LPD3D10SHADERREFLECTIONTYPE typedef ptr ID3D10ShaderReflectionType

;// {C530AD7D-9B16-4395-A979-BA2ECFF83ADD}
DEFINE_GUID( IID_ID3D10ShaderReflectionType , 0c530ad7dh , 9b16h , 4395h , 0a9h , 79h , 0bah , 2eh , 0cfh , 0f8h , 3ah , 0ddh)
;#undef INTERFACE
INTERFACE	EQU	<ID3D10ShaderReflectionType>
DECLARE_INTERFACE( ID3D10ShaderReflectionType)
;{
STDMETHOD  GetDesc , :ptr D3D10_SHADER_TYPE_DESC
STDMETHOD_  ID3D10ShaderReflectionType * , GetMemberTypeByIndex , :DWORD
STDMETHOD_  ID3D10ShaderReflectionType * , GetMemberTypeByName , :LPSTR
STDMETHOD_  LPCSTR , GetMemberTypeName , :DWORD
;}
DECLARE_INTERFACE_END

;ID3D10ShaderReflectionVariable typedef ID3D10ShaderReflectionVariable

LPD3D10SHADERREFLECTIONVARIABLE typedef ptr ID3D10ShaderReflectionVariable

;// {1BF63C95-2650-405d-99C1-3636BD1DA0A1}
DEFINE_GUID( IID_ID3D10ShaderReflectionVariable , 1bf63c95h , 2650h , 405dh , 99h , 0c1h , 36h , 36h , 0bdh , 1dh , 0a0h , 0a1h)
;#undef INTERFACE
INTERFACE	EQU	<ID3D10ShaderReflectionVariable>
DECLARE_INTERFACE( ID3D10ShaderReflectionVariable)
;{
STDMETHOD  GetDesc , :ptr D3D10_SHADER_VARIABLE_DESC
STDMETHOD_  ID3D10ShaderReflectionType * , GetType
;}
DECLARE_INTERFACE_END

;ID3D10ShaderReflectionConstantBuffer typedef ID3D10ShaderReflectionConstantBuffer

LPD3D10SHADERREFLECTIONCONSTANTBUFFER typedef ptr ID3D10ShaderReflectionConstantBuffer

;// {66C66A94-DDDD-4b62-A66A-F0DA33C2B4D0}
DEFINE_GUID( IID_ID3D10ShaderReflectionConstantBuffer , 66c66a94h , 0ddddh , 4b62h , 0a6h , 6ah , 0f0h , 0dah , 33h , 0c2h , 0b4h , 0d0h)
;#undef INTERFACE
INTERFACE	EQU	<ID3D10ShaderReflectionConstantBuffer>
DECLARE_INTERFACE( ID3D10ShaderReflectionConstantBuffer)
;{
STDMETHOD  GetDesc , :ptr D3D10_SHADER_BUFFER_DESC
STDMETHOD_  ID3D10ShaderReflectionVariable * , GetVariableByIndex , :DWORD
STDMETHOD_  ID3D10ShaderReflectionVariable * , GetVariableByName , :LPSTR
;}
DECLARE_INTERFACE_END

;ID3D10ShaderReflection typedef ID3D10ShaderReflection

LPD3D10SHADERREFLECTION typedef ptr ID3D10ShaderReflection

;// {D40E20B6-F8F7-42ad-AB20-4BAF8F15DFAA}
DEFINE_GUID( IID_ID3D10ShaderReflection , 0d40e20b6h , 0f8f7h , 42adh , 0abh , 20h , 4bh , 0afh , 8fh , 15h , 0dfh , 0aah)
;#undef INTERFACE
INTERFACE	EQU	<ID3D10ShaderReflection>
DECLARE_INTERFACE_( ID3D10ShaderReflection , IUnknown)
;{
STDMETHOD  QueryInterface , :REFIID, :ptr LPVOID
STDMETHOD_  ULONG , AddRef
STDMETHOD_  ULONG , Release
STDMETHOD  GetDesc , :ptr D3D10_SHADER_DESC
STDMETHOD_  ID3D10ShaderReflectionConstantBuffer * , GetConstantBufferByIndex , :DWORD
STDMETHOD_  ID3D10ShaderReflectionConstantBuffer * , GetConstantBufferByName , :LPSTR
STDMETHOD  GetResourceBindingDesc , :DWORD, :ptr D3D10_SHADER_INPUT_BIND_DESC
STDMETHOD  GetInputParameterDesc , :DWORD, :ptr D3D10_SIGNATURE_PARAMETER_DESC
STDMETHOD  GetOutputParameterDesc , :DWORD, :ptr D3D10_SIGNATURE_PARAMETER_DESC
;}
DECLARE_INTERFACE__END

;//////////////////////////////////////////////////////////////////////////////
;// APIs //////////////////////////////////////////////////////////////////////
;//////////////////////////////////////////////////////////////////////////////
ifdef __cplusplus
;extern "C"
;{
endif ;//__cplusplus
;//----------------------------------------------------------------------------
;// D3D10CompileShader:
;// ------------------
;// Compiles a shader.
;//
;// Parameters:
;//  pSrcFile
;//      Source file name.
;//  hSrcModule
;//      Module handle. if NULL, current module will be used.
;//  pSrcResource
;//      Resource name in module.
;//  pSrcData
;//      Pointer to source code.
;//  SrcDataLen
;//      Size of source code, in bytes.
;//  pDefines
;//      Optional NULL-terminated array of preprocessor macro definitions.
;//  pInclude
;//      Optional interface pointer to use for handling #include directives.
;//      If this parameter is NULL, #includes will be honored when compiling
;//      from file, and will error when compiling from resource or memory.
;//  pFunctionName
;//      Name of the entrypoint function where execution should begin.
;//  pProfile
;//      Instruction set to be used when generating code.  The D3D10 entry
;//      point currently supports only "vs_4_0", "ps_4_0", and "gs_4_0".
;//  Flags
;//      See D3D10_SHADER_xxx flags.
;//  ppShader
;//      Returns a buffer containing the created shader.  This buffer contains
;//      the compiled shader code, as well as any embedded debug and symbol
;//      table info.  (See D3D10GetShaderConstantTable)
;//  ppErrorMsgs
;//      Returns a buffer containing a listing of errors and warnings that were
;//      encountered during the compile.  If you are running in a debugger,
;//      these are the same messages you will see in your debug output.
;//----------------------------------------------------------------------------
D3D10CompileShader proto WINSTDCALLCONV :LPSTR, :DWORD, :LPSTR, :ptr D3D10_SHADER_MACRO, :LPD3D10INCLUDE, :LPSTR, :LPSTR, :DWORD, :ptr ptr ID3D10Blob, :ptr ptr ID3D10Blob
;//----------------------------------------------------------------------------
;// D3D10DisassembleShader:
;// ----------------------
;// Takes a binary shader, and returns a buffer containing text assembly.
;//
;// Parameters:
;//  pShader
;//      Pointer to the shader byte code.
;//  BytecodeLength
;//      Size of the shader byte code in bytes.
;//  EnableColorCode
;//      Emit HTML tags for color coding the output?
;//  pComments
;//      Pointer to a comment string to include at the top of the shader.
;//  ppDisassembly
;//      Returns a buffer containing the disassembled shader.
;//----------------------------------------------------------------------------
D3D10DisassembleShader proto WINSTDCALLCONV :ptr , :DWORD, :BOOL, :LPSTR, :ptr ptr ID3D10Blob
;//----------------------------------------------------------------------------
;// D3D10GetPixelShaderProfile/D3D10GetVertexShaderProfile/D3D10GetGeometryShaderProfile:
;// -----------------------------------------------------
;// Returns the name of the HLSL profile best suited to a given device.
;//
;// Parameters:
;//  pDevice
;//      Pointer to the device in question
;//----------------------------------------------------------------------------
D3D10GetPixelShaderProfile proto WINSTDCALLCONV :ptr ID3D10Device
D3D10GetVertexShaderProfile proto WINSTDCALLCONV :ptr ID3D10Device
D3D10GetGeometryShaderProfile proto WINSTDCALLCONV :ptr ID3D10Device
;//----------------------------------------------------------------------------
;// D3D10ReflectShader:
;// ------------------
;// Creates a shader reflection object that can be used to retrieve information
;// about a compiled shader
;//
;// Parameters:
;//  pShaderBytecode
;//      Pointer to a compiled shader (same pointer that is passed into
;//      ID3D10Device::CreateShader)
;//  BytecodeLength
;//      Length of the shader bytecode buffer
;//  ppReflector
;//      [out] Returns a ID3D10ShaderReflection object that can be used to
;//      retrieve shader resource and constant buffer information
;//
;//----------------------------------------------------------------------------
D3D10ReflectShader proto WINSTDCALLCONV :ptr , :DWORD, :ptr ptr ID3D10ShaderReflection
;//----------------------------------------------------------------------------
;// D3D10PreprocessShader
;// ---------------------
;// Creates a shader reflection object that can be used to retrieve information
;// about a compiled shader
;//
;// Parameters:
;//  pSrcData
;//      Pointer to source code
;//  SrcDataLen
;//      Size of source code, in bytes
;//  pFileName
;//      Source file name (used for error output)
;//  pDefines
;//      Optional NULL-terminated array of preprocessor macro definitions.
;//  pInclude
;//      Optional interface pointer to use for handling #include directives.
;//      If this parameter is NULL, #includes will be honored when assembling
;//      from file, and will error when assembling from resource or memory.
;//  ppShaderText
;//      Returns a buffer containing a single large string that represents
;//      the resulting formatted token stream
;//  ppErrorMsgs
;//      Returns a buffer containing a listing of errors and warnings that were
;//      encountered during assembly.  If you are running in a debugger,
;//      these are the same messages you will see in your debug output.
;//----------------------------------------------------------------------------
D3D10PreprocessShader proto WINSTDCALLCONV :LPSTR, :DWORD, :LPSTR, :ptr D3D10_SHADER_MACRO, :LPD3D10INCLUDE, :ptr ptr ID3D10Blob, :ptr ptr ID3D10Blob
;//////////////////////////////////////////////////////////////////////////
;//
;// Shader blob manipulation routines
;// ---------------------------------
;//
;// void *pShaderBytecode - a buffer containing the result of an HLSL
;//  compilation.  Typically this opaque buffer contains several
;//  discrete sections including the shader executable code, the input
;//  signature, and the output signature.  This can typically be retrieved
;//  by calling ID3D10Blob::GetBufferPointer() on the returned blob
;//  from HLSL's compile APIs.
;//
;// UINT BytecodeLength - the length of pShaderBytecode.  This can
;//  typically be retrieved by calling ID3D10Blob::GetBufferSize()
;//  on the returned blob from HLSL's compile APIs.
;//
;// ID3D10Blob **ppSignatureBlob(s) - a newly created buffer that
;//  contains only the signature portions of the original bytecode.
;//  This is a copy; the original bytecode is not modified.  You may
;//  specify NULL for this parameter to have the bytecode validated
;//  for the presence of the corresponding signatures without actually
;//  copying them and creating a new blob.
;//
;// Returns E_INVALIDARG if any required parameters are NULL
;// Returns E_FAIL is the bytecode is corrupt or missing signatures
;// Returns S_OK on success
;//
;//////////////////////////////////////////////////////////////////////////
D3D10GetInputSignatureBlob proto WINSTDCALLCONV :ptr , :DWORD, :ptr ptr ID3D10Blob
D3D10GetOutputSignatureBlob proto WINSTDCALLCONV :ptr , :DWORD, :ptr ptr ID3D10Blob
D3D10GetInputAndOutputSignatureBlob proto WINSTDCALLCONV :ptr , :DWORD, :ptr ptr ID3D10Blob
;//----------------------------------------------------------------------------
;// D3D10GetShaderDebugInfo:
;// -----------------------
;// Gets shader debug info.  Debug info is generated by D3D10CompileShader and is
;// embedded in the body of the shader.
;//
;// Parameters:
;//  pShaderBytecode
;//      Pointer to the function bytecode
;//  BytecodeLength
;//      Length of the shader bytecode buffer
;//  ppDebugInfo
;//      Buffer used to return debug info.  For information about the layout
;//      of this buffer, see definition of D3D10_SHADER_DEBUG_INFO above.
;//----------------------------------------------------------------------------
D3D10GetShaderDebugInfo proto WINSTDCALLCONV :ptr , :DWORD, :ptr ptr ID3D10Blob
ifdef __cplusplus
;}
endif ;//__cplusplus
endif ;//__D3D10SHADER_H__

;--- warnings: 11
;--- errors: 0
;--- end of file ---
